1) Create a working directory and add to your .bashrc file the lines:

export TRK_BIN=/home/your-user/.../your-working-dir/
export TRK_GRND=/home/your-user/.../trk-software-ground/
export LD_LIBRARY_PATH=$TRK_GRND/lib:$LD_LIBRARY_PATH

then update the .bashrc file:

# cd /home/your-user/
# source .bashrc

2) Create the executables:

# cd /home/your-user/.../trk-software-ground
# make all

(the Makefile is not very sophisticated, to make it run might require some 
adjustments... sorry)

3) Install the programs in your working directory by executing:

# make install

The following files and directory will be created:
   bin-aux/      - (auxiliary files)
   level0.exe    - program to go from RAW to LEVEL0
   level1.exe    -  "       "  "  "   LEVEL0 to LEVEL1
   level2.exe    -  "       "  "  "   LEVEL1 to LEVEL2

The same structure is created in the directory run-test/. Here you can find 
an example (run-test.sh) on how to use these programs (follow the instructions 
in WHAT-TO-DO).

4) IN case you don't need to reduce tracker files, but you need only to use 
LEVEL2 nt-uples to get track information and calculate the particle 
trajectory, you can follow the example in the directory "utilities/template/". 
This is an example on how to access LEVEL2 nt-uples and how to link the 
tracker library ("libtrk.a"; see "doc/libtrk.txt" for more info) in a fortran 
program (template.f). 

This directory contains all the parameters needed for tracker data reduction. 

During the compilation of "level2.exe" program, these auxiliary files are moved
in the directory "bin-aux", which is created together with the executable. 
The "official" files (that is those that are copied in "bin-aux") for 2005 data 
are the following:

align_param/parameters_l*s*.dat 
align_param/mech_pos.dat 

eta_param/eta*_binning.dat 
eta_param/eta*_bin*_l*.dat 

charge_param/charge-l*.dat 

field_meas/*.rz 

(NB! The program "level2-2003.exe" is associated with different parameters sets, 
labelled with "2003")

All the other files and directory are different versions of the same parameters,
that are kept in some case just for historical reasons.
It follows a short description of the data.  

==============================================================================
- align_param-COLONNE  
Alignment parameters for the coloumns, from CERN beam test 2003

- align_param-2003
Same alignment parameters as align_param-COLONNE, associated with the new
mechanical positions

- align_param-OTTICI   
Alignment parameters for the whole tracker, using the optical measurements to 
fix the relative positions  of sensors in the two reference plane. 
The procedure was applied to test 2003 data, and compared with the previous.
The result seems not good. It may be due to a variation of the sensor position
after inserting the planes in the tower.

- align_param-MUONI    
First set of alignment parameters obtained with muon, from Rome 2005 runs. 
The idea is to correct the parameters for the columns, from test 2003, by
varying the relative positions of the column (by means of tarcks that cross 
the columns).
The result is not satisfactory. 
The reason is that meanwhile we realized that from 2003 to 2005 the planes
moved... becouse of the vibration test.

- align_param-SHIFTS-then-MUONI  
We then tried to apply the procedure above, after having corrected the relative
positions of the planes for x and y translations, evaluated from the residual
distributions.

- align_param-COLONNE-shift2
Since also the procedure above does not convince, we first corrected the 
parameters from the shifts only (better evaluated) and see what happens.
However, even after the correction, the residual distributions are not centered.

- align_param-COLONNE-shift3
The correction above was iterated.

- align_param-COLONNE-RIALIGN
The column have been realigned, by using the measured muon momentum corrected 
for the estimated deflection offset.

- align_param-COLONNE-RIALIGN2
The column have been realigned, by using the measured muon momentum corrected 
for the estimated deflection offset.
The alignment was repeated to get correct error estimates for all the columns.
Now residuals and charge ratio seems to be ok and the offset in eta is removed.

- align_param-COSMIC
Alignment of the whole spectrometer using cosmic muons, strarting from the
align_param-COLONNE-RIALIGN2 for the single columns
                                                                                                                         
==============================================================================

- mech_pos.dat-old
- mech_pos.dat-new
Mechanical position of the sensors. In the old version the tickness of the
carbon stiffners was wrong. 
NB!! To each set of allignment parameters must be associated the proper  
mechanical positions (old-old new-new ... but for some exceptions)

==============================================================================

- charge_param-2003
- eta_param-2003
Charge correlation parameters and eta2 correction functions, evaluated from test
2003 data. In this set of parameters not all the angular bins are populated.

==============================================================================

- data-card.dat
This file is needed for charge correlation calibration.

parametri di allineamento singole colonne ottenuti con cosmici roma 2005, 
versione 2

a partire da quelli del test 2003 
mettendo un offset in deflessione di 0.0018 (GV/c)^-1

errore ok per tutte le colonne

Alignment parameters obtained starting from the alignment parameters of the
colums (from test beam), by means of ground muons. 
Muon tracks crossing two different colums were selected, and parameters were
corrected for the relative misalignment of the colums. 

      integer tdcid(12),evcount(12)
      integer tdcmask(12),adc(4,12),tdc(4,12)
      integer temp1(12),temp2(12)
      COMMON / tofvar /tdcid,evcount,tdcmask,adc,tdc,temp1,temp2


      integer*4 trig_evcount
      integer pmtpl(3), trigrate(6), dltime(2), s4calcount(2)
      integer pmtcount1(24), pmtcount2(24)
      integer*4 patternbusy(3)
      integer patterntrig(6), trigconf
      COMMON / trig / trig_evcount, pmtpl, trigrate, dltime,
     &     s4calcount, pmtcount1, pmtcount2, 
     &     patternbusy, patterntrig, trigconf

      parameter (ntp_tof=17)

      logical good
      integer nev_trk
      common / event_tof /good,nev_trk

*************************************************************************
*     
*     functions.f
*     
*     - !???
*     
*     needs:
*     - !???
*     
*     output variables:
*     - !???
*     
*     to be called inside !???
*
*
*     MODIFIED in order to have in input a 
*     REAL-defined strip number instead of INTEGER
*     
*************************************************************************


      function pitch(view)      !it gives the strip pitch, knowing the view number

      real pitch
      integer view

      include './commontracker.f'

      if(mod(view,2).eq.0) then !X
         pitch=pitchX
      else                      !Y
         pitch=pitchY
      endif

      end



c------------------------------------------------------------------------



      function npl(view)        !it gives the plane number, knowing the view number.
                                ! plane 1 = views 11+12, calorimeter side
                                ! ...
                                ! plane 6 = views 1+2, TRD side
      integer npl,view

      npl=7-(INT((view-1)/2)+1)

      end



c------------------------------------------------------------------------



      function nld(istrip,view) 
*     it gives the number of the ladder, knowing the
*     strip number (1..3072) and the view number.
*     the first strip belongs to ladder 1

      integer istrip,view,nld

      include './commontracker.f'


      nld=INT((istrip-1)/nstrips_ladder)+1

      end


c------------------------------------------------------------------------


      function nviewx(iplane)   !it gives the view number of a X plane

      integer nviewx,iplane

      nviewx=2*(7-iplane)

      end


c------------------------------------------------------------------------

      function nviewy(iplane)   !it gives the view number of a Y plane

      integer nviewy,iplane

      nviewy=2*(7-iplane)-1

      end

c------------------------------------------------------------------------




      function nvk(istrip)      

*     it gives the number of the VA1, knowing the strip
*     number (1..3072).
*     the first strip belongs to VA1 1
      integer istrip,nvk

      include './commontracker.f'

      nvk=INT((istrip-1)/nstrips_va1)+1
      
      end



c------------------------------------------------------------------------



      function nst(istrip)      

*     it gives the VA1 strip, knowing the strip number
*     (1..3072).
*     the first strip belongs to VA1 1

      integer istrip,nst

      include './commontracker.f'

      nst=INT(mod((istrip-1),nstrips_va1))+1
      

      end

      
c$$$c------------------------------------------------------------------------
c$$$
c$$$c     NB: le coordinate in mech_pos.dat sono calcolate a partire da alcuni dati
c$$$c     contenuti in commontracker.f. forse si puo' evitare mech_pos.dat e mettere
c$$$c     tutto in commontracker.f
c$$$
c$$$
c$$$      subroutine mech_sensor    !it reads sensors coordinates (in PAMELA reference
c$$$                                ! frame) from a text file and it uses them to fill
c$$$                                ! x/y/z_mech_sensor variables, taking into account
c$$$                                ! last plane inversion
c$$$
c$$$      include './commontracker.f'
c$$$      include './common_tracks.f'
c$$$
c$$$      real xvec(nladders_view),yvec(2),zvec(nplanes)
c$$$
c$$$      integer id                !file identifier
c$$$      logical od                !.true. if the specified unit is connected to a file
c$$$
c$$$      do id=20,100,1            !opens the file using a free file id
c$$$        inquire (id, opened=od)
c$$$        if(.not.od) goto 666
c$$$      enddo      
c$$$ 666  continue
c$$$
c$$$      open(id,FILE='../common/mech_pos.dat') !sensors centres coordinates in mm in 
c$$$                                ! PAMELA reference frame:
c$$$                                ! the first plane is the one with lowest Z (the one
c$$$                                ! nearest the calorimeter)
c$$$                                ! the first ladder is the one with lowest X (the
c$$$                                ! one on which the first X strip is)
c$$$                                ! the first sensor is the one with lowest Y (the
c$$$                                ! one on which the first Y strip is) for planes
c$$$                                ! 2..6. for plane 1 the first sensor has higher Y
c$$$
c$$$      read(20,*) xvec
c$$$      read(20,*) yvec
c$$$      read(20,*) zvec
c$$$
c$$$      do i=1,nplanes
c$$$        do j=1,nladders_view
c$$$          do k=1,2
c$$$            x_mech_sensor(i,j,k)=xvec(j)
c$$$            y_mech_sensor(i,j,k)=yvec(k)
c$$$            z_mech_sensor(i,j,k)=zvec(i)
c$$$            if(i.eq.1) then     !y coordinates of first plane (11th view) are
c$$$              y_mech_sensor(i,j,k)=-yvec(k) ! exchanged due to last plane inversion
c$$$            endif              
c$$$          enddo
c$$$        enddo
c$$$      enddo
c$$$
c$$$      close(id)
c$$$
c$$$
c$$$c$$$  ! *** INIZIO DEBUG ***
c$$$c$$$  do i=1,6
c$$$c$$$  do j=1,3
c$$$c$$$  do k=1,2
c$$$c$$$  c            print*,x_mech_sensor(1,j,k)
c$$$c$$$  print*,y_mech_sensor(i,j,k)
c$$$c$$$  c            print*,z_mech_sensor(i,j,k)
c$$$c$$$  enddo
c$$$c$$$  enddo
c$$$c$$$  print*,' '
c$$$c$$$  enddo
c$$$c$$$  ! *** FINE DEBUG ***
c$$$
c$$$      
c$$$      return
c$$$      end


c$$$c------------------------------------------------------------------------
c$$$
c$$$c     NB: le coordinate in mech_pos.dat sono calcolate a partire da alcuni dati
c$$$c     contenuti in commontracker.f. forse si puo' evitare mech_pos.dat e mettere
c$$$c     tutto in commontracker.f
c$$$
c$$$
c$$$      subroutine mech_sensor    
c$$$c     !it reads sensors coordinates (in PAMELA reference
c$$$c     ! frame) from a text file and it uses them to fill
c$$$c     ! x/y/z_mech_sensor variables, taking into account
c$$$c     ! last plane inversion
c$$$
c$$$      include './commontracker.f'
c$$$      include './common_tracks.f'
c$$$
c$$$      real xvec(nladders_view),yvec(2),zvec(nplanes)
c$$$
c$$$      integer id                !file identifier
c$$$      logical od                !.true. if the specified unit is connected to a file
c$$$
c$$$      do id=20,100,1            !opens the file using a free file id
c$$$        inquire (id, opened=od)
c$$$        if(.not.od) goto 666
c$$$      enddo      
c$$$ 666  continue
c$$$
c$$$c      open(id,FILE='../common/mech_pos.dat') !sensors centres coordinates in mm in 
c$$$c      open(id,FILE='source/common/mech_pos.dat') 
c$$$c      call system('cp $TRK_GRND/source/common/mech_pos.dat .')
c$$$      print *,'Opening file: mech_pos.dat'
c$$$      open(id,FILE='./bin-aux/mech_pos.dat',IOSTAT=iostat) 
c$$$c     !sensors centres coordinates in mm in 
c$$$c     ! PAMELA reference frame:
c$$$c     ! the first plane is the one with lowest Z (the one
c$$$c     ! nearest the calorimeter)
c$$$c     ! the first ladder is the one with lowest X (the
c$$$c     ! one on which the first X strip is)
c$$$c     ! the first sensor is the one with lowest Y (the
c$$$c     ! one on which the first Y strip is) for planes
c$$$c     ! 2..6. for plane 1 the first sensor has higher Y
c$$$      
c$$$      if(iostat.ne.0)then
c$$$         print*,'MECH_SENSOR: *** Error in opening file ***'
c$$$         return
c$$$      endif
c$$$
c$$$      read(id,*) xvec
c$$$      read(id,*) yvec
c$$$      read(id,*) zvec
c$$$
c$$$      do i=1,nplanes
c$$$        do j=1,nladders_view
c$$$          do k=1,2
c$$$            x_mech_sensor(i,j,k)=xvec(j)
c$$$            y_mech_sensor(i,j,k)=yvec(k)
c$$$            z_mech_sensor(i,j,k)=zvec(i)
c$$$            if(i.eq.1) then     !y coordinates of first plane (11th view) are
c$$$              y_mech_sensor(i,j,k)=-yvec(k) ! exchanged due to last plane inversion
c$$$            endif              
c$$$          enddo
c$$$        enddo
c$$$      enddo
c$$$
c$$$      close(id)
c$$$c      call system('rm -f mech_pos.dat')
c$$$
c$$$c$$$                                ! *** INIZIO DEBUG ***
c$$$c$$$      do i=1,6
c$$$c$$$c        do j=1,3
c$$$c$$$          do k=1,2
c$$$c$$$            j=1
c$$$c$$$c            print*,x_mech_sensor(1,j,k)
c$$$c$$$            print*,y_mech_sensor(i,j,k)
c$$$c$$$c            print*,z_mech_sensor(i,j,k)
c$$$c$$$          enddo
c$$$c$$$c        enddo
c$$$c$$$        print*,' '
c$$$c$$$      enddo
c$$$c$$$                                ! *** FINE DEBUG ***
c$$$
c$$$      
c$$$      return
c$$$      end
c$$$

c------------------------------------------------------------------------


      function coordsi(istrip,view) 
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*     it gives the strip coordinate in micrometers,
*     knowing the strip number (1..3072) and the view
*     number. the origin of the coordinate is on the
*     centre of the sensor the strip belongs to.
*     the axes directions are the same as in the PAMELA
*     reference frame (i.e.: the 11th view coordinate
*     direction has to be inverted here)
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

c      integer is,view,istrip

      integer view,is,istrip
      real coordsi

      include './commontracker.f'

c     NB mettere il 1024 nel commontracker...!???



      is=istrip                 !it stores istrip number
      is=mod(is-1,1024)+1       !it puts all clusters on a single ladder

      coordsi=0.
      
      if(mod(view,2).eq.0) then !X view

        if((is.le.3).or.(is.ge.1022)) then !X has 1018 strips...
          print*,'functions: WARNING: false X strip: strip ',is
        endif

        is=is-3                 !4 =< is =< 1021 --> 1 =< is =< 1018

        edge=edgeX
        dim=SiDimX

      elseif(mod(view,2).eq.1) then !Y view

        edge=edgeY
        dim=SiDimY

c$$$        if(view.eq.11) then     !INVERSIONE!???
c$$$          is=1025-is
c$$$        endif

      endif

      p=pitch(view)

      coord1=(is-1)*p           !referred to 1st sensor strip
      coord1=coord1+edge        !referred to sensor edge
      
      coordsi=coord1-dim/2      !referred to the centre of the sensor

      if(view.eq.11) then       !INVERSION: it puts y axis in the same direction for all views
        coordsi=-coordsi
      endif
      
      end


c------------------------------------------------------------------------


      function acoordsi(strip,view) 
*
*     same as COORDSI, but accept a real value of strip!!!
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*     it gives the strip coordinate in micrometers,
*     knowing the strip number (1..3072) and the view
*     number. the origin of the coordinate is on the
*     centre of the sensor the strip belongs to.
*     the axes directions are the same as in the PAMELA
*     reference frame (i.e.: the 11th view coordinate
*     direction has to be inverted here)
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

c      integer is,view,istrip

      integer view,is,istrip
      real coordsi,acoordsi
      real strip,stripladder


      include './commontracker.f'

c     NB mettere il 1024 nel commontracker...!???

      istrip = int(strip+0.5)   !istrip stores the closest integer to strip      

      is=istrip                 !it stores istrip number
      is=mod(is-1,1024)+1       !it puts all clusters on a single ladder
      
      coordsi=0.
      
      if(mod(view,2).eq.0) then !X view

        if((is.le.3).or.(is.ge.1022)) then !X has 1018 strips...
          print*,'functions: WARNING: false X strip: strip ',is
        endif

        is=is-3                 !4 =< is =< 1021 --> 1 =< is =< 1018

        edge=edgeX
        dim=SiDimX

      elseif(mod(view,2).eq.1) then !Y view

        edge=edgeY
        dim=SiDimY

c$$$        if(view.eq.11) then     !INVERSIONE!???
c$$$          is=1025-is
c$$$        endif

      endif


      stripladder = float(is)+(strip-float(istrip))!cluster position relative to ladder
      p=pitch(view)

ccccc coord1=(is-1)*p           !referred to 1st sensor strip
      coord1=(stripladder-1)*p  !referred to 1st sensor strip
      coord1=coord1+edge        !referred to sensor edge
      acoordsi=coord1-dim/2      !referred to the centre of the sensor

      if(view.eq.11) then       !INVERSION: it puts y axis in the same direction for all views
        acoordsi=-acoordsi
      endif
      
      end



c------------------------------------------------------------------------


      function coord(coordsi,view,ladder,sen) 
*     it gives the coordinate in 
*     micrometers, knowing the coordinate in the sensor
*     frame, the view, the ladder and the sensor numbers.
*     the origin is in the centre of the magnet (PAMELA
*     reference frame)

      include './commontracker.f'
      include './common_tracks.f'

      integer view,ladder,sen
      integer sx,sy,sz

      real coord,coordsi,trasl

c$$$c     parameter (offset=4365.)  !???  ! in um !CONTROLLARE SE HA SENSO:
c$$$                                ! dalle misure sul piano dovrebbe essere 4970,
c$$$                                ! dallo shift dei residui viene 4365
c$$$                                ! va messo .ne.0. se in mech_sensor assegno ai 
c$$$                                ! sensori del sesto piano coordinate Y uguali
c$$$                                ! a quelle degli altri sensori
c$$$      parameter (offset=0.)     !???  altrimenti se il sesto piano ha coordinate
c$$$                                ! Y diverse offset dovrebbe essere .eq.0.
c$$$                                ! CONTROLLARE CON I GRAFICI DEI RESIDUI!!!


      coord=0.
      
      sx=ladder
      sy=sen
      sz=npl(view)

      if(mod(view,2).eq.0) then !X view

        trasl=x_mech_sensor(sz,sx,sy) !in mm

      elseif(mod(view,2).eq.1) then !Y view

        trasl=y_mech_sensor(sz,sx,sy) !in mm

c$$$        if(view.eq.11) then     !INVERSIONE!???INUTILE, ne e' gia' tenuto conto
c$$$          coordsi=coordsi+offset ! in y_mech_pos...
c$$$        endif

      endif

      coord=coordsi+trasl*1000.

      end


c------------------------------------------------------------------------
c------------------------------------------------------------------------

c     double precision version of the above subroutine

      double precision function dcoord(coordsi,view,ladder,sen) !it gives the coordinate in 
                                ! micrometers, knowing the coordinate in the sensor
                                ! frame, the view, the ladder and the sensor numbers.
                                ! the origin is in the centre of the magnet (PAMELA
                                ! reference frame)

      include './commontracker.f'
      include './common_tracks.f'

      integer view,ladder,sen
      integer sx,sy,sz

c      double precision dcoord
      double precision coordsi,trasl

c$$$c     parameter (offset=4365.)  !???  ! in um !CONTROLLARE SE HA SENSO:
c$$$                                ! dalle misure sul piano dovrebbe essere 4970,
c$$$                                ! dallo shift dei residui viene 4365
c$$$                                ! va messo .ne.0. se in mech_sensor assegno ai 
c$$$                                ! sensori del sesto piano coordinate Y uguali
c$$$                                ! a quelle degli altri sensori
c$$$      parameter (offset=0.)     !???  altrimenti se il sesto piano ha coordinate
c$$$                                ! Y diverse offset dovrebbe essere .eq.0.
c$$$                                ! CONTROLLARE CON I GRAFICI DEI RESIDUI!!!


      dcoord=0.
      
      sx=ladder
      sy=sen
      sz=npl(view)

      if(mod(view,2).eq.0) then !X view

        trasl=x_mech_sensor(sz,sx,sy) !in mm

      elseif(mod(view,2).eq.1) then !Y view

        trasl=y_mech_sensor(sz,sx,sy) !in mm

c$$$        if(view.eq.11) then     !INVERSIONE!???INUTILE, ne e' gia' tenuto conto
c$$$          dcoordsi=dcoordsi+offset ! in y_mech_pos...
c$$$        endif

      endif

      dcoord=coordsi+trasl*1000.

      end


c------------------------------------------------------------------------

*************************************************************************
*     
*     Subroutine fillpedsig.f
*     
*     - fills bad, pedestal and sigma variables with respective values from
*     level0 histograms, in order to perform cluster identification !???
*     - fills bad, pedestal_t and sigma_t variables with respective truncated
*     values from level0 histograms, in order to perform data decompression
*     
*     needs:
*     - level0 pedestal, sigma and badstrip histograms
*     
*     output variables:
*     - bad
*     - pedestal
*     - pedestal_t
*     - sigma
*     - sigma_t
*     
*     to be called inside ./reduction.f
*     
*************************************************************************


      subroutine fillpedsig

      include '../common/commontracker.f'
      include '../common/calib.f'

      external nvk
      external nst


c------------------------------------------------------------------------
c     
c     local variables
c     
c------------------------------------------------------------------------

      real content(nstrips_view) !temporary array

c------------------------------------------------------------------------
c     
c     loops on views filling badstrip, pedestal and sigma variables from
c     level0 histograms
c     
c------------------------------------------------------------------------

      do iv=1,nviews
         call HUNPAK(id_hi_bad+iv,content,' ',0) !puts histo contents in an array
         do is=1,nstrips_view   !fills variables with array values
            bad(iv,nvk(is),nst(is))=INT(content(is))
         enddo

         call HUNPAK(id_hi_ped+iv,content,' ',0)
         do is=1,nstrips_view
            pedestal(iv,nvk(is),nst(is))=content(is)
            pedestal_t(iv,nvk(is),nst(is))=AINT(content(is)) !truncated value
         enddo

         call HUNPAK(id_hi_sig+iv,content,' ',0)
         do is=1,nstrips_view
            sigma(iv,nvk(is),nst(is))=content(is)
            sigma_t(iv,nvk(is),nst(is))=ANINT(content(is)) !truncated value
         enddo

         do is=1,nstrips_view!inversione (a volte ritornano, quasi...) badstrip!???
            if(bad(iv,nvk(is),nst(is)).eq.1) then
               bad(iv,nvk(is),nst(is))=0
            else
               bad(iv,nvk(is),nst(is))=1
            endif
         enddo

      enddo

      


c$$$  C     
c$$$  C     inversione vista 11: devo riinvertire i valori contenuti negli istogrammi
c$$$  C     per poter decomprimere i dati compressi (che sono stati messi a diritto 
c$$$  C     nel vettore datatracker, senza inversione 11). quello che mi serve e' di
c$$$  C     riinvertire pedestal_t(11,nvk(is),nst(is)) e (anche se forse non lo uso)
c$$$  C     sigma_t(11,nvk(is),nst(is)) !??? 
c$$$  C     
c$$$  do is=1,nstrips_view
c$$$  content(is) = pedestal_t(11,nvk(is),nst(is))
c$$$  enddo
c$$$  
c$$$  do is=1,nstrips_view
c$$$  offset=5121
c$$$  if(is.le.2048) offset=3073
c$$$  if(is.le.1024) offset=1025
c$$$  iss=offset-is
c$$$  
c$$$  pedestal_t(11,nvk(iss),nst(iss)) = content(is)
c$$$  enddo
c$$$  
c$$$  
c$$$  do is=1,nstrips_view
c$$$  content(is) = sigma_t(11,nvk(is),nst(is))
c$$$  enddo
c$$$  
c$$$  do is=1,nstrips_view
c$$$  offset=5121
c$$$  if(is.le.2048) offset=3073
c$$$  if(is.le.1024) offset=1025
c$$$  iss=offset-is
c$$$  
c$$$  sigma_t(11,nvk(iss),nst(iss)) = content(is)
c$$$  enddo
c$$$  C     
c$$$  C     fine inversione vista 11 !???
c$$$  C     

      return
      end

*************************************************************************
*     Program analysis.f
*
*     - reads cluster information (LEVEL1, reduction.f output ntuple)
*     - perform track identification and fit
*     - create LEVEL2 ntuple
*
*************************************************************************
      program momanhough

      include '../common/commontracker.f'
      include '../common/common_momanhough.f'
c      include '../common/common_level2debug.f'
      include '../common/common_mech.f'
      include '../common/common_xyzPAM.f'
      include '../common/common_mini_2.f'
      include '../common/calib.f'
      include '../common/level1.f'
      include '../common/level2.f'

c      include '../common/momanhough_init.f'

*     flag to set debug mode
      logical DEBUG
      common/dbg/DEBUG
      logical DBG_FILLED
      data DBG_FILLED/.false./

*     flag to chose PFA
      character*10 PFA
      common/FINALPFA/PFA


c      parameter (inf=1.e8)      !just a huge number...
        
*     external functions
      external npl
      external acoordsi,coordsi,nld,coord,dcoord
c------------------------------------------------------------------------
c     
c     local variables
c     
c------------------------------------------------------------------------

      character*24 processing_date

      parameter (lun_data_level1=71) !data file id number
      parameter (lun_data_level2=72) !data file id number
      parameter (lun_data_calib=74) !data file id number

      character*74 data_file    !data file name
      character*74 data_dir    !data file name
      character*74 data_file_calib
      character*74 data_file_level1
      character*74 data_file_level2
# ifndef TEST2003
      parameter(ncalibmax=50)
      character*40 file_calib(ncalibmax)
      parameter(lun_calib_list=66) !calibration list file id
      integer which_calib_last
# endif

      integer minevent          !first event to be analysed
c      logical FIMAGE            !


      COMMON/QUEST/IQUEST(100)  
c     !permette di ottenere ntuple funzionanti nonostante
c     ! il messaggio dei 64K di RZOUT...!???

c*****************************************************
cccccc 11/9/2005 modified by david fedele
c      swcode=202
cccccc 12/10/2005 modified by Elena Vannuccini
      swcode=300
c****************************************************
c------------------------------------------------------------------------
c     
c     HBOOK initialization
c     
c------------------------------------------------------------------------
     
      call HLIMIT(NWPAWC)


c------------------------------------------------------------------------
c     
c     reads input informations
c     
c------------------------------------------------------------------------
      call fdate(processing_date)
      write(*,101)
     $     processing_date
 101  format(/
     $      ,'*** *** *** *** *** *** *** *** *** *** *** *** ***',/
     $      ,'*                                                 *',/
     $      ,'* ANALYSIS                                        *',/     
     $      ,'*                                                 *',/
     $      ,'*** *** *** *** *** *** *** *** *** *** *** *** ***',/
     $     ,a24,/
     $     )

 111  format(a)
      print*,'Data directory:'      
      read(*,111)data_dir
      print*,data_dir
      print*,'File identifier: (DATE_NUM)'    
      read(*,*)data_file     
      print*,data_file
      minevent=1
      print*,'Maximum number of events to be analized:' !20000
      read(*,*) ntotev
      print*,ntotev    
      print*,'Position-finding algorythm: (GOG2,ETA2)'
      read(*,*)PFA
      PFA=PFA(1:lnblnk(PFA))
      print*,PFA
      print*,'DEBUG mode: (T, F)'
 11   format(l1)
      read(*,11)DEBUG
      print*,DEBUG
      print*,'---------------------------------------------------'


****** INITIALIZATIONS *************************************

*     1) read charge-correlation parameters
      print*,' '
      print*,'- read charge-correlation parameters'
      print*,' '
      call readchargeparam

*     1) read mip parameters
      print*,' '
      print*,'- read mip parameters'
      print*,' '
      call readmipparam

*     2) read z coordinates of the planes
      print*,' '
      print*,'- read z coordinates of the planes'
      print*,' '
      call mech_sensor          !reads sensors centres coordinates
      do ip=1,nplanes
        fitz(ip)=z_mech_sensor(ip,1,1)*0.1 !cm
*     gets planes mechanical z positions
*     (in mm) and sets them in micrometers
      enddo                     


*     3) read eta PFA parameters
      print*,' '
      print*,'- read P.F.A. parameters'
      print*,' '
      call readetaparam
      
      print*,' '
      print*,'- First guess P.F.A. >>>> ',PFAdef
      print*,' '
      print*,'- Final       P.F.A. >>>> ',PFA
      print*,' '

*     4) read magnetic field map      
      print*,' '
      print*,'- read magnetic field map'
      print*,' '
c      call read_B(5)            !legge il nome da STI!!.. temporaneo
c      call read_B_2maps(5)            !legge il nome da STI!!.. temporaneo
      call read_B

*     5) read allignment parameters
      print*,' '
      print*,'- read aligment parameters'
      print*,' '
      call readalignparam
 
************************************************************





c------------------------------------------------------------------------
c     
c     LEVEL 2 ntuple booking
c     
c------------------------------------------------------------------------


 503  format(a,'DW_',a,'_level2.rz')
      write(data_file_level2,503)
     $     data_dir(1:LNBLNK(data_dir))
     $     ,data_file(1:LNBLNK(data_file))

      print*,''
      print*,'------------------------------------'
      print*,'  Creating LEVEL2 rz file'
      print*,'  ',data_file_level2
      print*,'------------------------------------'


C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C     largest RZ file: IQUEST(10) records x LREC words x 4 byte
C     with the following settings: 65000 x 4096 x 4 = 1G
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
      IQUEST(10)=65000          
c     !permette di ottenere ntuple funzionanti nonostante
c     ! il messaggio dei 64K di RZOUT...!???
      call HROPEN(lun_data_level2,
     $     'LEVEL2',data_file_level2,'QNP',4096,istat) !opens rz  
      if(istat.ne.0) goto 19      
      call book_level2

      if(DEBUG)then
         print*,'(creating DEBUG nt-uple and histos)'
         call book_debug
      endif
      


c------------------------------------------------------------------------
c     
c     fills bad variables with online DSP bad strips from calib histograms
c     for bad strip exclusion
c     
c------------------------------------------------------------------------
        
# ifdef TEST2003
c------------------------------------------------------------------------
c     
c     opens calib file
c     
c------------------------------------------------------------------------

 505  format(a,'output_',a,'_calib.rz')
      write(data_file_calib,505)
     $     data_dir(1:LNBLNK(data_dir))
     $     ,data_file(1:LNBLNK(data_file))
         
      print*,' '
      print*,'OPENING CALIB FILE...', data_file_calib
      
      IQUEST(10)=65000
      call HROPEN(lun_data_calib,'IN',data_file_calib,'QP',4096,istat)
      if(istat.ne.0) goto 17
      call HCDIR('//IN',' ')
      
      call HRIN(0,9999,0)       !puts histograms in memory
      
      print*,' '

      print*,' '
      print*,'READING PEDESTAL, SIGMA AND BADSTRIP HISTOGRAMS...'
      print*,' '
      
      call fillpedsig
      
      call HREND('IN')
      close (lun_data_calib)  
# else

      print*,' '
      print*,'OPENING CALIBRATION-LIST FILE:'
 501  format(a,'DW_',a,'_calib.txt')
      write(data_file_calib,501)
     $     data_dir(1:LNBLNK(data_dir))
     $     ,data_file(1:LNBLNK(data_file))
      print*,data_file_calib
      open(lun_calib_list,
     $     FILE=data_file_calib(1:LNBLNK(data_file_calib))
     $     ,STATUS='UNKNOWN'
     $     ,IOSTAT=iostat
     $     )

 113  format(i5,'    ',a25)

      do i=1,ncalibmax

         read(lun_calib_list,113,IOSTAT=iostat) n_cal_list
     $        ,file_calib(i)(1:LNBLNK(file_calib(i)))
         if(iostat.ne.0)then
            ncal=i-1
            goto 2000
         endif
         print*,n_cal_list,' - '
     $        ,file_calib(i)(1:LNBLNK(file_calib(i)))

      enddo

 2000 close(lun_calib_list)
      which_calib_last=0

# endif 
      
c------------------------------------------------------------------------
c     
c     opens level1 file
c     
c------------------------------------------------------------------------

# ifdef TEST2003
 504  format(a,'output_',a,'_level1.rz')
# else
 504  format(a,'DW_',a,'_level1.rz')
# endif
      write(data_file_level1,504)
     $     data_dir(1:LNBLNK(data_dir))
     $     ,data_file(1:LNBLNK(data_file))
      print*,''
      print*,'OPENING LEVEL1 FILE:'
      print*,data_file_level1
      IQUEST(10)=65000          
c     !permette di ottenere ntuple funzionanti nonostante
c     ! il messaggio dei 64K di RZOUT...!???
      call HROPEN(lun_data_level1,
     $     'LEVEL1',data_file_level1,'QP',4096,istat) !opens rz  
      if(istat.ne.0) goto 19      
      call HRIN(ntp_level1,9999,20)       
      call access_level1
c      call HPRNTU(ntp_level1+20)  
      call HNOENT(ntp_level1+20,iemax0)
      print*,'  events',iemax0


************************************************************
************************************************************
************************************************************
*
*     start track analysis
*
************************************************************
************************************************************
************************************************************
      maxevent=minevent+ntotev-1
      do iev = minevent,MIN(iemax0,maxevent) !loop on events

         call HCDIR('//LEVEL1',' ')
         call HGNT(ntp_level1+20,iev,ierr) !reads an event
         if(ierr.ne.0) goto 21
*------------------------------------------------------
*        LEVEL2 N-TUPLE INITIALIZATIONS
         call init_level2
         if(DEBUG)call init_level2_debug
         if(DEBUG)DBG_FILLED=.false.

         if(.not.good1)then
            goto 8800           !fill nt-uple and go to next event
         endif
*------------------------------------------------------


# ifndef TEST2003
      
         if(which_calib.ne.which_calib_last.and.
     $        which_calib.ne.0)then
            
            data_file_calib=
     $           data_dir(1:LNBLNK(data_dir))//
     $           file_calib(which_calib)
     $           (1:LNBLNK(file_calib(which_calib)))
c     print*,data_file_calib
            print*,''
            print*,
     $           '@ event ',nev2
     $           ,'   (CPU pkt N.',pkt_num1,')'
            print*,'--> ',data_file_calib            
            IQUEST(10)=65000          
            call HROPEN(lun_data_calib,
     $           'CALIB',data_file_calib,'QP',4096,istat) !opens
            if(istat.ne.0) goto 19      
            call HRIN(0,9999,0)       
            call fillpedsig
            do iview=1,nviews
               call HDELET(id_hi_bad+iview)
               call HDELET(id_hi_ped+iview)
               call HDELET(id_hi_sig+iview)
            enddo
            call HREND('CALIB')
            close(lun_data_calib)            
            which_calib_last=which_calib           
            
         elseif(which_calib.eq.0)then
            
            nocalib=nocalib+1
            good2=.false.
            goto 8800 !fill nt-uple and go to next event
            
         endif

# endif

      
*------------------------------------------------------
*     cut on maximum number of clusters
*------------------------------------------------------
         if(nclstr1.gt.nclstrmax_level2)then
            goto 8800           !fill nt-uple and go to next event
         endif

         do i=1,nclstr1
            cl_used(i)=0        !init mask of clusters associated to a track
         enddo

         if(DEBUG)then
            print*,'----------------------------------'
            print*,iev,'   ** ',nev2
         endif

*     ///////////////////////////////////////////////
*     \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

         iflag=0
         call track_finding(iflag)
         if(iflag.eq.1)then     !bad event
            goto 880            !fill ntp and go to next event     
         endif 
c$$$*-------------------------------------------------------------------------------
c$$$*     STEP 1
c$$$*-------------------------------------------------------------------------------
c$$$*     X-Y cluster association
c$$$*     
c$$$*     Clusters are associated to form COUPLES
c$$$*     Clusters not associated in any couple are called SINGLETS
c$$$*
c$$$*     Track identification (Hough transform) and fitting is first done on couples. 
c$$$*     Hence singlets are possibly added to the track.
c$$$*    
c$$$*     Variables assigned by the routine "cl_to_couples" are those in the 
c$$$*     common blocks:
c$$$*     - common/clusters/cl_good
c$$$*     - common/couples/clx,cly,ncp_plane,ncp_tot,cp_useds1,cp_useds2
c$$$*     - common/singlets/ncls,cls,cl_single
c$$$*-------------------------------------------------------------------------------
c$$$*-------------------------------------------------------------------------------
c$$$
c$$$         iflag=0
c$$$         call cl_to_couples(iflag)
c$$$         if(iflag.eq.1)then     !bad event
c$$$            goto 880            !fill ntp and go to next event            
c$$$         endif
c$$$
c$$$*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c$$$*     selezione di tracce pulite per diagnostica
c$$$*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c$$$c$$$         if(DEBUG)then
c$$$c$$$            do ip=1,nplanes 
c$$$c$$$               if(ncp_plane(ip).ne.1)good2=.false.
c$$$c$$$            enddo 
c$$$c$$$c            if(good2.eq.0)goto 100!next event 
c$$$c$$$c            if(good2.eq.0)goto 880!fill ntp and go to next event 
c$$$c$$$         endif
c$$$         
c$$$ 
c$$$
c$$$*-----------------------------------------------------
c$$$*-----------------------------------------------------
c$$$*     HOUGH TRASFORM
c$$$*-----------------------------------------------------
c$$$*-----------------------------------------------------
c$$$
c$$$
c$$$*-------------------------------------------------------------------------------
c$$$*     STEP 2
c$$$*-------------------------------------------------------------------------------
c$$$*     
c$$$*     Association of couples to form
c$$$*     - DOUBLETS in YZ view
c$$$*     - TRIPLETS in XZ view
c$$$*    
c$$$*     Variables assigned by the routine "cp_to_doubtrip" are those in the 
c$$$*     common blocks:
c$$$*     - common/hough_param/
c$$$*     $     alfayz1,  !Y0
c$$$*     $     alfayz2,  !tg theta-yz
c$$$*     $     alfaxz1,  !X0
c$$$*     $     alfaxz2,  !tg theta-xz
c$$$*     $     alfaxz3   !1/r
c$$$*     - common/doublets/ndblt,cpyz1,cpyz2
c$$$*     - common/triplets/ntrpt,cpxz1,cpxz2,cpxz3
c$$$*-------------------------------------------------------------------------------
c$$$*-------------------------------------------------------------------------------
c$$$
c$$$         iflag=0
c$$$         call cp_to_doubtrip(iflag)
c$$$         if(iflag.eq.1)then     !bad event
c$$$            goto 880            !fill ntp and go to next event            
c$$$         endif
c$$$
c$$$
c$$$*-------------------------------------------------------------------------------
c$$$*     STEP 3
c$$$*-------------------------------------------------------------------------------
c$$$*     
c$$$*     Classification of doublets and triplets to form CLOUDS,  
c$$$*     according to distance in parameter space. 
c$$$*     
c$$$*     cloud = cluster of points (doublets/triplets) in parameter space
c$$$*
c$$$*     
c$$$*    
c$$$*     Variables assigned by the routine "doub_to_YZcloud" are those in the 
c$$$*     common blocks:
c$$$*     - common/clouds_yz/                   
c$$$*     $     nclouds_yz                        
c$$$*     $     ,alfayz1_av,alfayz2_av           
c$$$*     $     ,ptcloud_yz,db_cloud,cpcloud_yz
c$$$*
c$$$*     Variables assigned by the routine "trip_to_XZcloud" are those in the 
c$$$*     common blocks:
c$$$*      common/clouds_xz/                   
c$$$*     $      nclouds_xz     xz2_av,alfaxz3_av 
c$$$*     $     ,ptcloud_xz,tr_cloud,cpcloud_xz           
c$$$*-------------------------------------------------------------------------------
c$$$*-------------------------------------------------------------------------------
c$$$
c$$$         iflag=0
c$$$         call doub_to_YZcloud(iflag)
c$$$         if(iflag.eq.1)then     !bad event
c$$$            goto 880            !fill ntp and go to next event            
c$$$         endif
c$$$         iflag=0
c$$$         call trip_to_XZcloud(iflag)
c$$$         if(iflag.eq.1)then     !bad event
c$$$            goto 880            !fill ntp and go to next event            
c$$$         endif
c$$$
c*****************************************************
cccccc 01/12/2005 modified by elena
         if(DEBUG)then
            call fill_level2_clouds
            call HCDIR('//LEVEL2',' ')
            call HFNT(ntp_level2+1) !fill DEBUG nt-uple
            DBG_FILLED=.true.
         endif
c*****************************************************


         iflag=0
         call track_fitting(iflag)
         if(iflag.eq.1)then     !bad event
            goto 880            !fill ntp and go to next event     
         endif 


c$$$
c$$$*-------------------------------------------------------------------------------
c$$$*     STEP 4   (ITERATED until any other physical track isn't found)
c$$$*-------------------------------------------------------------------------------
c$$$*     
c$$$*     YZ and XZ clouds are combined in order to obtain the initial guess
c$$$*     of the candidate-track parameters.
c$$$*     A minimum number of matching couples between YZ and XZ clouds is required.
c$$$*
c$$$*     A TRACK CANDIDATE is defined by 
c$$$*     - the couples resulting from the INTERSECTION of the two clouds, and 
c$$$*     - the associated track parameters (evaluated by performing a zero-order  
c$$$*       track fitting) 
c$$$*
c$$$*     The NTRACKS candidate-track parameters are stored in common block:
c$$$*    
c$$$*     - common/track_candidates/NTRACKS,AL_STORE
c$$$*     $     ,XV_STORE,YV_STORE,ZV_STORE
c$$$*     $     ,XM_STORE,YM_STORE,ZM_STORE
c$$$*     $     ,RESX_STORE,RESY_STORE
c$$$*     $     ,AXV_STORE,AYV_STORE
c$$$*     $     ,XGOOD_STORE,YGOOD_STORE
c$$$*     $     ,CP_STORE,RCHI2_STORE
c$$$*
c$$$*-------------------------------------------------------------------------------
c$$$*-------------------------------------------------------------------------------
c$$$         ntrk=0                 !counter of identified physical tracks
c$$$
c$$$11111    continue               !<<<<<<< come here when performing a new search
c$$$
c$$$         iflag=0
c$$$         call clouds_to_ctrack(iflag)
c$$$         if(iflag.eq.1)then     !no candidate tracks found
c$$$            goto 880            !fill ntp and go to next event   
c$$$         endif
c$$$
c$$$         FIMAGE=.false.         !processing best track (not track image)
c$$$         ibest=0                !best track among candidates
c$$$         iimage=0               !track image
c$$$*     ------------- select the best track -------------
c$$$         rchi2best=1000000000.
c$$$         do i=1,ntracks
c$$$            if(RCHI2_STORE(i).lt.rchi2best.and.
c$$$     $         RCHI2_STORE(i).gt.0)then
c$$$               ibest=i
c$$$               rchi2best=RCHI2_STORE(i)
c$$$            endif
c$$$         enddo
c$$$         if(ibest.eq.0)goto 880 !>> no good candidates 
c$$$*-------------------------------------------------------------------------------     
c$$$*     The best track candidate (ibest) is selected and a new fitting is performed. 
c$$$*     Previous to this, the track is refined by:
c$$$*     - possibly adding new COUPLES or SINGLETS from the missing planes
c$$$*     - evaluating the coordinates with improved PFAs 
c$$$*       ( angle-dependent ETA algorithms )
c$$$*-------------------------------------------------------------------------------
c$$$
c$$$ 1212    continue               !<<<<< come here to fit track-image
c$$$
c$$$         if(.not.FIMAGE)then    !processing best candidate 
c$$$            icand=ibest            
c$$$         else                   !processing image
c$$$            icand=iimage
c$$$            iimage=0
c$$$         endif
c$$$         if(icand.eq.0)then
c$$$            print*,'HAI FATTO UN CASINO!!!!!! icand = ',icand
c$$$     $           ,ibest,iimage
c$$$            return
c$$$         endif
c$$$
c$$$*     *-*-*-*-*-*-*-*-*-*-*-*-*-*-*
c$$$         call refine_track(icand)
c$$$*     *-*-*-*-*-*-*-*-*-*-*-*-*-*-*
c$$$
c$$$*     **********************************************************
c$$$*     ************************** FIT *** FIT *** FIT *** FIT ***
c$$$*     **********************************************************
c$$$         do i=1,5
c$$$            AL(i)=dble(AL_STORE(i,icand))
c$$$         enddo
c$$$         ifail=0                !error flag in chi2 computation
c$$$         jstep=0                !# minimization steps
c$$$
c$$$         call mini_2(jstep,ifail)
c$$$         if(ifail.ne.0) then
c$$$            if(DEBUG)then
c$$$               print *,
c$$$     $              '*** MINIMIZATION FAILURE *** (mini_2) '
c$$$     $              ,iev
c$$$            endif
c$$$            chi2=-chi2 
c$$$         endif 
c$$$         
c$$$         if(DEBUG)then
c$$$            print*,'----------------------------- improved track coord'
c$$$22222       format(i2,' * ',3f10.4,' --- ',4f10.4,' --- ',2f4.0,2f10.5)
c$$$            do ip=1,6
c$$$               write(*,22222)ip,zm(ip),xm(ip),ym(ip)
c$$$     $              ,xm_A(ip),ym_A(ip),xm_B(ip),ym_B(ip)
c$$$     $              ,xgood(ip),ygood(ip),resx(ip),resy(ip)
c$$$            enddo
c$$$         endif
c$$$
c$$$c         rchi2=chi2/dble(ndof)
c$$$         if(DEBUG)then
c$$$            print*,' ' 
c$$$            print*,'****** SELECTED TRACK *************'
c$$$            print*,'#         R. chi2        RIG'
c$$$            print*,' --- ',chi2,' --- '
c$$$     $           ,1./abs(AL(5)) 
c$$$            print*,'***********************************'
c$$$         endif
c$$$*     **********************************************************
c$$$*     ************************** FIT *** FIT *** FIT *** FIT ***
c$$$*     **********************************************************
c$$$
c$$$
c$$$*     ------------- search if the track has an IMAGE -------------
c$$$*     ------------- (also this is stored )           -------------
c$$$         if(FIMAGE)goto 122     !>>> jump! (this is already an image)
c$$$*     now search for track-image, by comparing couples IDs
c$$$         do i=1,ntracks
c$$$            iimage=i
c$$$            do ip=1,nplanes
c$$$               if(     CP_STORE(nplanes-ip+1,icand).ne.
c$$$     $              -1*CP_STORE(nplanes-ip+1,i) )iimage=0
c$$$            enddo
c$$$            if(  iimage.ne.0.and.
c$$$c     $           RCHI2_STORE(i).le.CHI2MAX.and.
c$$$c     $           RCHI2_STORE(i).gt.0.and.
c$$$     $           .true.)then 
c$$$               if(DEBUG)print*,'Track candidate ',iimage
c$$$     $              ,' >>> TRACK IMAGE >>> of'
c$$$     $              ,ibest
c$$$               goto 122         !image track found
c$$$            endif
c$$$         enddo
c$$$ 122     continue
c$$$
c$$$*     --- and store the results --------------------------------
c$$$         ntrk = ntrk + 1                   !counter of found tracks
c$$$         if(.not.FIMAGE
c$$$     $        .and.iimage.eq.0) image(ntrk)= 0
c$$$         if(.not.FIMAGE
c$$$     $        .and.iimage.ne.0)image(ntrk)=ntrk+1 !this is the image of the next
c$$$         if(FIMAGE)     image(ntrk)=ntrk-1 !this is the image of the previous
c$$$
c$$$         call fill_level2_tracks(ntrk)     !==> good2=.true.
c$$$c         print*,'++++++++++ iimage,fimage,ntrk,image '
c$$$c     $        ,iimage,fimage,ntrk,image(ntrk)
c$$$
c$$$         if(ntrk.eq.NTRKMAX)then
c$$$            if(DEBUG)
c$$$     $           print*,
c$$$     $           '** warning ** number of identified '// 
c$$$     $           'tracks exceeds vector dimension '
c$$$     $           ,'( ',NTRKMAX,' )'
c$$$cc            good2=.false.
c$$$            goto 880            !fill ntp and go to next event
c$$$         endif
c$$$         if(iimage.ne.0)then
c$$$            FIMAGE=.true.       !
c$$$            goto 1212           !>>> fit image-track
c$$$         endif
c$$$
c$$$*     --- then remove selected clusters (ibest+iimage) from clouds ----
c$$$         call clean_XYclouds(ibest)
c$$$         if(iflag.eq.1)then     !bad event
c$$$            goto 880            !fill ntp and go to next event            
c$$$         endif
c$$$
c$$$*     **********************************************************
c$$$*     condition to start a new search
c$$$*     **********************************************************
c$$$         ixznew=0
c$$$         do ixz=1,nclouds_xz
c$$$            if(ptcloud_xz(ixz).ge.nptxz_min)ixznew=1
c$$$         enddo
c$$$         iyznew=0
c$$$         do iyz=1,nclouds_yz
c$$$            if(ptcloud_yz(iyz).ge.nptyz_min)iyznew=1
c$$$         enddo
c$$$         
c$$$         if(ixznew.ne.0.and.
c$$$     $      iyznew.ne.0.and.
c$$$     $        rchi2best.le.CHI2MAX.and.
c$$$c     $        rchi2best.lt.15..and.
c$$$     $        .true.)then
c$$$            if(DEBUG)then
c$$$               print*,'***** NEW SEARCH ****'
c$$$            endif
c$$$            goto 11111          !try new search
c$$$            
c$$$         endif
c$$$*     **********************************************
c$$$
*     >>>>>>>>>>>>>>>>>>> NT-UPLE filling <<<<<<<<<<<<<<<<<<<<
*       +   +   +   +   +   +   +   +   +   +   +   +   +   +   +   +   +
*      / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ /
*     +   +   +   +   +   +   +   +   +   +   +   +   +   +   +   +   +   

 880     continue

*     **********************************************************
*     stores info about clusters not associated with any track
*     **********************************************************

c*****************************************************
cccccc 27/9/2005 modified by david fedele
*     count #cluster per plane not associated to any track
c$$$         do icl=1,nclstr1
c$$$            if(cl_used(icl).eq.0)then !cluster not included in any track
c$$$               ip=nplanes-npl(VIEW(icl))+1
c$$$               if(mod(VIEW(icl),2).eq.0)nclsx(ip)=nclsx(ip)+1
c$$$               if(mod(VIEW(icl),2).eq.1)nclsy(ip)=nclsy(ip)+1
c$$$            endif
c$$$c            print*,icl,cl_used(icl),cl_good(icl),ip,VIEW(icl)!nclsx(ip),nclsy(ip)
c$$$         enddo
c**********************************************************************

         call fill_level2_siglets

c         print*,'****** ',iev,' - ',ntrk,nclsx,nclsy
c         print*,'****** ',iev,' - ',ntrk,' --- ',(BdL(i),i=1,ntrk)

         if(DEBUG)then

            print*,''
            print*,'DONE!'
            print*,''
            print*,'* summary *'
            print*,'tracks    ',ntrk
            print*,'cl used   ',(cl_used(i),i=1,nclstr1)
c*****************************************************
c$$$cccccc 27/9/2005 modified by david fedele
c$$$            print*,'cl unused (x-y)'
c$$$            do ip=1,nplanes
c$$$               print*,ip,' << ',nclsx(ip),nclsy(ip)
c$$$            enddo
c******************************************************
            print*,''
            print*,''
         endif

 8800    continue


*     ///////////////////////////////////////////////
*     \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

         call HCDIR('//LEVEL2',' ')
         call HFNT(ntp_level2)  !fill LEVEL2 nt-uple         
         if(.not.DBG_FILLED.and.DEBUG)
     $        print*,'@@@@@@@@@@@@',ntp_level2+1,nev2_nt
         if(.not.DBG_FILLED.and.DEBUG)call HFNT(ntp_level2+1)

 100     continue
      enddo                     !end loop on events

c------------------------------------------------------------------------
c     
c     no error exit
c     
c------------------------------------------------------------------------

c$$$      print*,' '
c$$$      print*,'REDUCTION SUCCESSFULLY COMPLETED'
c$$$      print*,' '
c$$$      print*,' '
      
      goto 9000                 !happy ending


c------------------------------------------------------------------------
c     
c     data file opening error
c     
c------------------------------------------------------------------------
 19   continue
      
      print*,' '
      print*,'ERROR OPENING DATA FILE: ',data_file
      print*,' '
      print*,' '
      
      goto 9000                 !the end

c------------------------------------------------------------------------
c     
c     level1 ntuple event reading error
c     
c------------------------------------------------------------------------
      
 21   continue
      
      print*,' '
      print*,'ERROR WHILE READING LEVEL1 NTUPLE, AT EVENT
     $     : ',iev
      print*,' '
      print*,' '
      
      goto 9000                 !the end

c------------------------------------------------------------------------
c     
c     calib file opening error
c     
c------------------------------------------------------------------------
      
 17   continue
      
      print*,' '
      print*,'preanalysis: ERROR OPENING INPUT FILE: ',data_file_calib
      print*,' '
      print*,' '
      
      goto 9000                 !the end

c------------------------------------------------------------------------
c     
c     closes files and exits
c     
c------------------------------------------------------------------------

 9000 continue
      
      if(DEBUG)call HPRNTU(ntp_level2+1)
      call HPRNTU(ntp_level2)
      print*,''
      call HCDIR('//LEVEL2',' ')
      call HROUT(ntp_level2,ICYCLE,'T')
      print *,'- Stored LEVEL2 nt-uple (',nev2,' entries )'
      if(DEBUG)call HROUT(ntp_level2+1,ICYCLE,'T')
      if(DEBUG)print *,'- Stored DEBUG nt-uple '
      call HREND('level2')
      close(lun_data_level2)

      call HCDIR('//LEVEL1',' ')
      call HREND('level1')
      close(lun_data_level1)

      stop
      end


************************************************************


# include "momanhough-subroutines.F"

*************************************************************************
*     This version of momanhough performs tracker CALIBRATIONS:
*     - eta functions
*     - charge correlation
*     - ADC-to-MIP conversion
*     -------------------------------------------------------------------
*     It works as it follow:
*     - it reads cluster information (read a list of LEVEL1 ntuples, 
*       output of reduction.f)
*     - it performs track identification, select good tracks (6 hit planes) 
*       and perform first-order fit
*     - it calculate calibration variables
*     - it creates a LEVEL2 ntuple with selected events (in order to check)
*
*************************************************************************
      program momanhough

      include '../common/commontracker.f'
      include '../common/common_momanhough.f'
      include '../common/momanhough_init.f'
      include '../common/common_level2debug.f'
      include '../common/common_mech.f'
      include '../common/common_xyzPAM.f'
      include '../common/common_mini_2.f'
      include '../common/calib.f'
      include '../common/level1.f'
      include '../common/level2.f'
      include '../common/common_calibration.f'

*     flag to set debug mode
      logical DEBUG
      common/dbg/DEBUG
      logical DONTDO
      data DONTDO/.true./
c$$$*     flag to chose PFA
c$$$      character*10 PFA
c$$$      common/FINALPFA/PFA


c      parameter (inf=1.e8)      !just a huge number...
        
*     external functions
      external npl
      external acoordsi,coordsi,nld,coord,dcoord
c------------------------------------------------------------------------
c     
c     local variables
c     
c------------------------------------------------------------------------

      character*24 processing_date

      parameter (nfile_max=500)
      parameter (lun_data_level1=71) !data file id number
      parameter (lun_data_level2=72) !data file id number
      parameter (lun_data_calib=74)  !data file id number
c      parameter (lun_file_out=75)    !data file id number

      character*74 data_file    !data file name
      character*74 data_dir     !
      character*74 out_dir      !
      character*74 data_file_calib
      character*74 data_file_level1
      character*74 data_file_level2
      character*10 input_string(nfile_max)
      character*74 file_out
      character*74 fname_param
      character*7 rzdir



# ifndef TEST2003
      parameter(ncalibmax=50)
      character*40 file_calib(ncalibmax)
      parameter(lun_calib_list=66) !calibration list file id
      integer which_calib_last
# endif

      integer tottr
      integer minevent          !first event to be analysed
      logical FIMAGE            !


      COMMON/QUEST/IQUEST(100)  
c     !permette di ottenere ntuple funzionanti nonostante
c     ! il messaggio dei 64K di RZOUT...!???

# ifdef TEST2003
      parameter (nang=3)       !number of angular bins
      parameter (angstep=4.)
      parameter (angmin=-6.)
      print*,' '
      print*,'Set angular binning TEST 2003'
      print*,' '

      nangbin=nang
      do ia=1,nangbin
         angL(ia)=angmin+angstep*(ia-1)
         angR(ia)=angmin+angstep*ia
         print*,ia,' - ',angL(ia),angR(ia)
      enddo
      print*,' '


# else
c$$$      parameter (nang=21)       !number of angular bins
c$$$      parameter (angstep=2.)
c$$$      parameter (angmin=-21.)
c$$$      print*,' '
c$$$      print*,'Set angular binning Rome-2005'
c$$$      print*,' '
c$$$
c$$$      nangbin=nang
c$$$      do ia=1,nangbin
c$$$         angL(ia)=angmin+angstep*(ia-1)
c$$$         angR(ia)=angmin+angstep*ia
c$$$         print*,ia,' - ',angL(ia),angR(ia)
c$$$      enddo
c$$$      print*,' '

      parameter (nang=17)       !number of angular bins
*     NB angL and angR are created with length 21
      data angL
     $     /-21.,-17.,-13.,-11.,-9.,-7.,-5.,-3.,-1.
     $     ,1.,3.,5.,7.,9.,11.,13.,17.,0.,0.,0.,0./
      data angR
     $     /-17.,-13.,-11.,-9.,-7.,-5.,-3.,-1.
     $     ,1.,3.,5.,7.,9.,11.,13.,17.,21.,0.,0.,0.,0./
      print*,' '
      print*,'Set angular binning Rome-2005'
      print*,' '
      nangbin=nang
      do ia=1,nangbin
         print*,ia,' - ',angL(ia),angR(ia)
      enddo
      print*,' '

# endif

c------------------------------------------------------------------------
c     
c     HBOOK initialization
c     
c------------------------------------------------------------------------

      call HLIMIT(NWPAWC)


c------------------------------------------------------------------------
c     
c     reads input informations
c     
c------------------------------------------------------------------------
      call fdate(processing_date)
      write(*,101)
     $     processing_date
 101  format(/
     $      ,'*** *** *** *** *** *** *** *** *** *** *** *** ***',/
     $      ,'*                                                 *',/
     $      ,'* CALIBRATION                                     *',/     
     $      ,'*                                                 *',/
     $      ,'*** *** *** *** *** *** *** *** *** *** *** *** ***',/
     $     ,a24,/
     $     )

      print*,'Number of files to be analysed:'
      read(*,*)nfile
      print*,nfile
 111  format(a)
      print*,'Input data directory:'      
      read(*,111)data_dir
      print*,data_dir
      print*,'Output data directory:'      
      read(*,111)out_dir
      print*,out_dir
      print*,'List of file identifiers: (DATE_NUM)'
 300  format(A10)
      do i=1,nfile
         read(*,300)input_string(i)
         print*,input_string(i)
      enddo
      minevent=1
      print*,'Maximum number of events to be analized:' !20000
      read(*,*) ntotev
      print*,ntotev    
      print*,'DEBUG mode: (T, F)'
 11   format(l1)
      read(*,11)DEBUG
      print*,DEBUG
      print*,'---------------------------------------------------'


****** INITIALIZATIONS *************************************


*     2) read z coordinates of the planes
      print*,' '
      print*,'- read z coordinates of the planes'
      print*,' '
      call mech_sensor          !reads sensors centres coordinates
      do ip=1,nplanes
        fitz(ip)=z_mech_sensor(ip,1,1)*0.1 !cm
*     gets planes mechanical z positions
*     (in mm) and sets them in micrometers
      enddo                     

*     4) read magnetic field map      
      print*,' '
      print*,'- read magnetic field map'
      print*,' '
      call read_B

*     5) read allignment parameters
      print*,' '
      print*,'- read aligment parameters'
      print*,' '
      call readalignparam

************************************************************
************************************************************
************************************************************
************************************************************

      print*,' '
      print*,'---------------------------------------------------'
      print*,' '
      print*,'OPENING OUTPUT-HISTO FILES:'

 1010 format('LADDER',i1)
      do ilad=1,3

         write(rzdir,1010)ilad
         file_out=
     $        out_dir(1:LNBLNK(out_dir))//'trk-'
     $        //rzdir//'-histos.rz'
         print*,' -> '//file_out
         IQUEST(10)=65000
         call HROPEN(lun_file_out+ilad,rzdir,file_out,'PQN',4096,istat)
         if(istat.ne.0) goto 16 
         call HCDIR('//'//rzdir,' ')
         
         call HCDIR('//PAWC','')
         call HMDIR(rzdir,'S')

         call book_eta_histos
         call book_charge_histos
         call book_check_histos
         call HCDIR('//PAWC','')
         
      enddo

************************************************************
************************************************************
************************************************************
************************************************************
************************************************************
************************************************************
************************************************************
************************************************************
************************************************************
************************************************************
************************************************************
************************************************************

c------------------------------------------------------------------------
c     
c     LEVEL 2 ntuple booking
c     
c------------------------------------------------------------------------


 503  format(a,'DW__level2-calib.rz')
      write(data_file_level2,503)
     $     out_dir(1:LNBLNK(out_dir))
c     $     ,data_file(1:LNBLNK(data_file))
      
      print*,''
      print*,'------------------------------------'
      print*,'  Creating LEVEL2 rz file'
      print*,'  ',data_file_level2
      print*,'------------------------------------'
      

C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C     largest RZ file: IQUEST(10) records x LREC words x 4 byte
C     with the following settings: 65000 x 4096 x 4 = 1G
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
      IQUEST(10)=65000          
c     !permette di ottenere ntuple funzionanti nonostante
c     ! il messaggio dei 64K di RZOUT...!???
      call HROPEN(lun_data_level2,
     $     'LEVEL2',data_file_level2,'QNP',4096,istat) !opens rz  
      if(istat.ne.0) goto 19      
      call book_level2
         
      print*,' '
      print*,'---------------------------------------------------'
      print*,'           * * * START ANALYSIS * * *'
      print*,'---------------------------------------------------'
 
c------------------------------------------------------------------------
c     
c     loop on files
c     
c------------------------------------------------------------------------

      goodtr = 0
      tottr = 0
      do ifile = 1,nfile        !files loop

         print*,' '
         data_file = input_string(ifile)
         print*,'--> FILE ',ifile,': '//data_file(1:LNBLNK(data_file))

c------------------------------------------------------------------------
c     
c     fills bad variables with online DSP bad strips from calib histograms
c     for bad strip exclusion
c     
c------------------------------------------------------------------------
        
# ifdef TEST2003
c------------------------------------------------------------------------
c     
c     opens calib file
c     
c------------------------------------------------------------------------

 505     format(a,'output_',a,'_calib.rz')
         write(data_file_calib,505)
     $        data_dir(1:LNBLNK(data_dir))
     $        ,data_file(1:LNBLNK(data_file))
         
         print*,' '
         print*,'OPENING CALIB FILE...', data_file_calib
         
         IQUEST(10)=65000
         call HROPEN
     $        (lun_data_calib,'IN',data_file_calib,'QP',4096,istat)
         if(istat.ne.0) goto 17
         call HCDIR('//IN',' ')
         
         call HRIN(0,9999,0)    !puts histograms in memory
         
         print*,' '
         
         print*,' '
         print*,'READING PEDESTAL, SIGMA AND BADSTRIP HISTOGRAMS...'
         print*,' '
         
         call fillpedsig
         
         call HREND('IN')
         close (lun_data_calib)  
# else
      
         print*,' '
         print*,'OPENING CALIBRATION-LIST FILE:'
 501     format(a,'DW_',a,'_calib.txt')
         write(data_file_calib,501)
     $        data_dir(1:LNBLNK(data_dir))
     $        ,data_file(1:LNBLNK(data_file))
         print*,data_file_calib
         open(lun_calib_list,
     $        FILE=data_file_calib(1:LNBLNK(data_file_calib))
     $        ,STATUS='UNKNOWN'
     $        ,IOSTAT=iostat
     $        )
         
 113     format(i5,'    ',a25)
         
         do i=1,ncalibmax
            
            read(lun_calib_list,113,IOSTAT=iostat) n_cal_list
     $           ,file_calib(i)
c            file_calib(i)=file_calib(i)(1:LNBLNK(file_calib(i)))
            if(iostat.ne.0)then
               ncal=i-1
               goto 2000
            endif
            print*,n_cal_list,' - '
     $           ,file_calib(i)(1:LNBLNK(file_calib(i)))
            
         enddo
         
 2000    close(lun_calib_list)
         which_calib_last=0
         
# endif 
      
c------------------------------------------------------------------------
c     
c     opens level1 file
c     
c------------------------------------------------------------------------

# ifdef TEST2003
 504     format(a,'output_',a,'_level1.rz')
# else
 504     format(a,'DW_',a,'_level1.rz')
# endif
         write(data_file_level1,504)
     $      data_dir(1:LNBLNK(data_dir))
     $     ,data_file(1:LNBLNK(data_file))
         print*,''
         print*,'OPENING LEVEL1 FILE:'
         print*,data_file_level1
         IQUEST(10)=65000          
c     !permette di ottenere ntuple funzionanti nonostante
c     ! il messaggio dei 64K di RZOUT...!???
         call HROPEN(lun_data_level1,
     $        'LEVEL1',data_file_level1,'QP',4096,istat) !opens rz  
         if(istat.ne.0) goto 19      
         call HRIN(ntp_level1,9999,20)       
         call access_level1
c     call HPRNTU(ntp_level1+20)  
         call HNOENT(ntp_level1+20,iemax0)
         print*,'( ',iemax0,' events)'
         
         
************************************************************
************************************************************
************************************************************
*     
*     start track analysis
*
************************************************************
************************************************************
************************************************************
         nselect = 0
         maxevent=minevent+ntotev-1
         do iev = minevent,MIN(iemax0,maxevent) !loop on events
            
            call HCDIR('//LEVEL1',' ')
            call HGNT(ntp_level1+20,iev,ierr) !reads an event
            if(ierr.ne.0) goto 21

            tottr = tottr +1

*------------------------------------------------------
*        LEVEL2 N-TUPLE INITIALIZATIONS
            call init_level2
            if(.not.good1)then
*               goto 8800        !fill nt-uple and go to next event
               goto 100        !go to next event
            endif
*------------------------------------------------------


# ifndef TEST2003
      
            if(which_calib.ne.which_calib_last.and.
     $which_calib.ne.0)then
               
               data_file_calib=
     $              data_dir(1:LNBLNK(data_dir))//
     $              file_calib(which_calib)
     $              (1:LNBLNK(file_calib(which_calib)))
c     print*,data_file_calib
               print*,''
               print*,
     $              '@ event ',nev2
     $              ,'   (CPU pkt N.',pkt_num1,')'
               print*,'--> ',data_file_calib            
               IQUEST(10)=65000          
               call HROPEN(lun_data_calib,
     $              'CALIB',data_file_calib,'QP',4096,istat) !opens
               if(istat.ne.0) goto 19      
               call HRIN(0,9999,0)       
               call fillpedsig
               do iview=1,nviews
                  call HDELET(id_hi_bad+iview)
                  call HDELET(id_hi_ped+iview)
                  call HDELET(id_hi_sig+iview)
               enddo
               call HREND('CALIB')
               close(lun_data_calib)            
               which_calib_last=which_calib           
               
            elseif(which_calib.eq.0)then
               
               nocalib=nocalib+1
               good2=.false.
               goto 8800        !fill nt-uple and go to next event
               
            endif
            
# endif

      
*------------------------------------------------------
*     cut on maximum number of clusters
*------------------------------------------------------
*            if(nclstr1.gt.nclstrmax_level2)then
            if(nclstr1.gt.20)then
*               goto 8800        !fill nt-uple and go to next event
               goto 100        !go to next event
            endif
            
            do i=1,nclstr1
               cl_used(i)=0     !init mask of clusters associated to a track
            enddo
            
            if(DEBUG)then
               print*,'----------------------------------'
               print*,iev,'   ** ',nev2
            endif
            
*-------------------------------------------------------------------------------
*     STEP 1
*-------------------------------------------------------------------------------
*     X-Y cluster association
*     
*     Clusters are associated to form COUPLES
*     Clusters not associated in any couple are called SINGLETS
*
*     Track identification (Hough transform) and fitting is first done on couples. 
*     Hence singlets are possibly added to the track.
*    
*     Variables assigned by the routine "cl_to_couples" are those in the 
*     common blocks:
*     - common/clusters/cl_good
*     - common/couples/clx,cly,ncp_plane,ncp_tot,cp_useds1,cp_useds2
*     - common/singlets/ncls,cls,cl_single
*
*     NB - The routine version used for calibration is different from that used
*     for event processing. Different cluster selection is applied: 
*     - "ngoodstr" good strip around MAXS required (ngoodstr=2 => 5 good strips)
*     - no charge correlation required
*-------------------------------------------------------------------------------
*-------------------------------------------------------------------------------

            iflag=0
            call cl_to_couples_nocharge(iflag)
            if(iflag.eq.1)then  !bad event
*               goto 880         !fill ntp and go to next event            
               goto 100         !go to next event            
            endif
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*     PRE-SELEZIONE DI TRACCE PULITE 
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*     at least a couple per plane
            do ip=1,nplanes 
               if(ncp_plane(ip).eq.0)goto 100 !next event 
            enddo 
c     if(good2.eq.0)goto 880!fill ntp and go to next event 
            
*-----------------------------------------------------
*-----------------------------------------------------
*     HOUGH TRASFORM
*-----------------------------------------------------
*-----------------------------------------------------


*-------------------------------------------------------------------------------
*     STEP 2
*-------------------------------------------------------------------------------
*     
*     Association of couples to form
*     - DOUBLETS in YZ view
*     - TRIPLETS in XZ view
*    
*     Variables assigned by the routine "cp_to_doubtrip" are those in the 
*     common blocks:
*     - common/hough_param/
*     $     alfayz1,  !Y0
*     $     alfayz2,  !tg theta-yz
*     $     alfaxz1,  !X0
*     $     alfaxz2,  !tg theta-xz
*     $     alfaxz3   !1/r
*     - common/doublets/ndblt,cpyz1,cpyz2
*     - common/triplets/ntrpt,cpxz1,cpxz2,cpxz3
*-------------------------------------------------------------------------------
*-------------------------------------------------------------------------------

            iflag=0
            call cp_to_doubtrip(iflag)
            if(iflag.eq.1)then  !bad event
*               goto 880         !fill ntp and go to next event            
               goto 100         !go to next event            
            endif


*-------------------------------------------------------------------------------
*     STEP 3
*-------------------------------------------------------------------------------
*     
*     Classification of doublets and triplets to form CLOUDS,  
*     according to distance in parameter space. 
*     
*     cloud = cluster of points (doublets/triplets) in parameter space
*
*     
*    
*     Variables assigned by the routine "doub_to_YZcloud" are those in the 
*     common blocks:
*     - common/clouds_yz/                   
*     $     nclouds_yz                        
*     $     ,alfayz1_av,alfayz2_av           
*     $     ,ptcloud_yz,db_cloud,cpcloud_yz
*
*     Variables assigned by the routine "trip_to_XZcloud" are those in the 
*     common blocks:
*      common/clouds_xz/                   
*     $      nclouds_xz                        
*     $     ,alfaxz1_av,alfaxz2_av,alfaxz3_av 
*     $     ,ptcloud_xz,tr_cloud,cpcloud_xz           
*-------------------------------------------------------------------------------
*-------------------------------------------------------------------------------

            iflag=0
            call doub_to_YZcloud(iflag)
            if(iflag.eq.1)then  !bad event
*               goto 880         !fill ntp and go to next event            
               goto 100         !go to next event            
            endif
            iflag=0
            call trip_to_XZcloud(iflag)
            if(iflag.eq.1)then  !bad event
*               goto 880         !fill ntp and go to next event            
               goto 100         !go to next event            
            endif
            

*-------------------------------------------------------------------------------
*     STEP 4   (ITERATED until any other physical track isn't found)
*-------------------------------------------------------------------------------
*     
*     YZ and XZ clouds are combined in order to obtain the initial guess
*     of the candidate-track parameters.
*     A minimum number of matching couples between YZ and XZ clouds is required.
*
*     A TRACK CANDIDATE is defined by 
*     - the couples resulting from the INTERSECTION of the two clouds, and 
*     - the associated track parameters (evaluated by performing a zero-order  
*       track fitting) 
*
*     The NTRACKS candidate-track parameters are stored in common block:
*    
*     - common/track_candidates/NTRACKS,AL_STORE
*     $     ,XV_STORE,YV_STORE,ZV_STORE
*     $     ,XM_STORE,YM_STORE,ZM_STORE
*     $     ,RESX_STORE,RESY_STORE
*     $     ,AXV_STORE,AYV_STORE
*     $     ,XGOOD_STORE,YGOOD_STORE
*     $     ,CP_STORE,RCHI2_STORE
*
*-------------------------------------------------------------------------------
*-------------------------------------------------------------------------------
            ntrk=0              !counter of identified physical tracks
            
11111       continue            !<<<<<<< come here when performing a new search
            
            iflag=0
            call clouds_to_ctrack(iflag)
            if(iflag.eq.1)then  !no candidate tracks found
*               goto 880         !fill ntp and go to next event   
               goto 100         !go to next event            
            endif


*------------------------------------------------------
*     cut on maximum number of track candidates
*     (to have clean events)
*     NB: must be at least 2 to do not discard tracks
*     contained in a sensor column on Y view     
*
*     cut replaced with cut on the # cluster out of the track
*------------------------------------------------------
*            if(ntracks.gt.2)then
*               goto 8800        !fill nt-uple and go to next event
*               goto 100        !go to next event
*            endif
            

*            if(DEBUG)print*,'*GOOD!*'

            FIMAGE=.false.      !processing best track (not track image)
            ibest=0             !best track among candidates
            iimage=0            !track image
*     -----------------------------------------------------
*     --------------- select the best track ---------------
*     selection cuts:
*     - NX = NY = 6
*     -----------------------------------------------------
*
            rchi2best=100000.      
            do i=1,ntracks

               npx=0
               npy=0
               do ip=1,nplanes
                  npx=npx+XGOOD_STORE(ip,i)
                  npy=npy+YGOOD_STORE(ip,i)
               enddo
*               print*,
*     $         'Candidate ',i,' nx,ny ',npx,npy,' chi2 ',RCHI2_STORE(i)
               if(npx.eq.nplanes.and.npy.eq.nplanes)then
                  if(RCHI2_STORE(i).lt.rchi2best.and.
     $                 RCHI2_STORE(i).gt.0)then
                     ibest=i
                     rchi2best=RCHI2_STORE(i)
                  endif
               endif
            enddo
*     if(ibest.eq.0)goto 880 !>> no good candidates 
            if(ibest.eq.0)goto 100 !>> no good candidates 

*            print*,'BEST TRACK ',ibest,'  nx,ny',npx,npy

*            print*,'>>>> ',iev

*     -----------------------------------------------------
*     ------------- store the best track only -------------
*     -----------------------------------------------------
            ntr=1
            
            ntrk=ntr
            image(ntr)=0
            good2=.true.
            chi2_nt(ntr)        = RCHI2_STORE(ibest)
c     print*,chi2_nt(ntr)

*     ****************************************************
*     normalize the angles
*     ****************************************************
            pig=acos(-1.)
            phi   = AL_STORE(4,ibest)       
            sinth = AL_STORE(3,ibest)       
            if(sinth.lt.0)then  
               sinth = -sinth   
               phi = phi + pig  
            endif               
            npig = aint(phi/(2*pig)) 
            phi = phi - npig*2*pig 
            if(phi.lt.0)        
     $           phi = phi + 2*pig 
            AL_STORE(4,ibest) = phi         
            AL_STORE(3,ibest) = sinth       
*     ****************************************************
*     ... then assign the other variables
*     ****************************************************
            do i=1,5
               al_nt(i,ntr)     = AL_STORE(i,ibest)
c               print*,i,'al_nt(i,ntr)',al_nt(i,ntr)
               do j=1,5
                  coval(i,j,ntr) = 0 ! TEMPORANEO!!!!!!!!!!!!
               enddo
            enddo
            do ip=1,nplanes     ! loop on planes
               xgood_nt(ip,ntr) = XGOOD_STORE(ip,ibest)
               ygood_nt(ip,ntr) = YGOOD_STORE(ip,ibest)
               xm_nt(ip,ntr)    = XM_STORE(ip,ibest)
               ym_nt(ip,ntr)    = YM_STORE(ip,ibest)
               zm_nt(ip,ntr)    = ZM_STORE(ip,ibest)
               RESX_nt(IP,ntr)  = RESX_STORE(ip,ibest)
               RESY_nt(IP,ntr)  = RESY_STORE(ip,ibest)
               xv_nt(ip,ntr)    = XV_STORE(ip,ibest)
               yv_nt(ip,ntr)    = YV_STORE(ip,ibest)
               zv_nt(ip,ntr)    = ZV_STORE(ip,ibest)
               axv_nt(ip,ntr)   = AXV_STORE(ip,ibest)
               ayv_nt(ip,ntr)   = AYV_STORE(ip,ibest)
               
c               print*,ip,' xm_nt(ip,ntr)', xm_nt(ip,ntr)
c               print*,ip,' ym_nt(ip,ntr)', ym_nt(ip,ntr)
c               print*,ip,' zm_nt(ip,ntr)', zm_nt(ip,ntr)
c               print*,ip,' RESX_nt(ip,ntr)', RESX_nt(ip,ntr)
c               print*,ip,' RESY_nt(ip,ntr)', RESY_nt(ip,ntr)
c                print*,ip,' xv_nt(ip,ntr)',xv_nt(ip,ntr)
c                print*,ip,' yv_nt(ip,ntr)',yv_nt(ip,ntr)
c                print*,ip,' zv_nt(ip,ntr)',zv_nt(ip,ntr)
c                print*,ip,' axv_nt(ip,ntr)',axv_nt(ip,ntr)
c                print*,ip,' ayv_nt(ip,ntr)',ayv_nt(ip,ntr)

               id = CP_STORE(ip,ibest)
               icp = icp_cp(id)
               iclx = clx(nplanes-ip+1,icp)
               icly = cly(nplanes-ip+1,icp)
               which_cl_x(ip) = iclx
               which_cl_y(ip) = icly
               dedx_x(ip,ntr)   = dedx(iclx) 
               dedx_y(ip,ntr)   = dedx(icly)         
            enddo

c            call CalcBdL(100,xxxx,IFAIL)
c            if(ifps(xxxx).eq.1)BdL(ntr) = xxxx
            BdL(ntr) = 0

*     --- then remove selected clusters (ibest+iimage) from clouds ----
            call clean_XYclouds(ibest)
            if(iflag.eq.1)then  !bad event
*               goto 880         !fill ntp and go to next event            
               goto 100        !go to next event
            endif

*     >>>>>>>>>>>>>>>>>>> NT-UPLE filling <<<<<<<<<<<<<<<<<<<<
*       +   +   +   +   +   +   +   +   +   +   +   +   +   +   +   +   +
*      / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ / \ /
*     +   +   +   +   +   +   +   +   +   +   +   +   +   +   +   +   +   

 880        continue
*     **********************************************************
*     stores info about clusters not associated with any track
*     **********************************************************
c            call fill_level2_siglets

            if(DEBUG)then
               
               print*,''
               print*,'DONE!'
               print*,''
               print*,'* summary *'
               print*,'tracks    ',ntrk
               print*,'cl used   ',(cl_used(i),i=1,nclstr1)
c$$$               print*,'cl unused (x-y)'
c$$$               do ip=1,nplanes
c$$$                  print*,ip,' << ',nclsx(ip),nclsy(ip)
c$$$               enddo
               print*,''
               print*,''
            endif
            
            
 8800       continue


*     -----------------------------------------------------
*     +++++++++++++++++++++++++++++++++++++++++++++++++++++
*     calibrations:
*     +++++++++++++++++++++++++++++++++++++++++++++++++++++
*     -----------------------------------------------------


*     ==================================
*     //////////////////////////////////
*     Track selection
*     \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*     ==================================
*     - cut on number of planes
*      (fatto a monte... non mi ricordo perche')
c$$$            npx=0
c$$$            npy=0
c$$$            do ip=1,nplanes
c$$$               npx=npx+XGOOD_STORE(ip,i)
c$$$               npy=npy+YGOOD_STORE(ip,i)
c$$$            enddo
c$$$            if(.not.(npx.ge.5..and.npy.ge.5))goto 100
*     - chi^2 selection 
            rig = abs(1./al_nt(5,1))
c$$$            chicut = 5.         !100.
c$$$            chicut = chicut * ( 1.48 + 4.64/rig + 18.35/rig**2 )
c$$$            if(chi2_nt(1).gt.chicut)goto 100 !next event
            chicut = 20
            chicut = chicut *( 
c     $            3.9633*exp(-0.54485E-01*rig)
c     $           +0.99231
c     $           +10.835*exp(-0.67155*rig) )
     $            3.7032*exp(-0.41911E-01*rig)
     $           +0.85355
     $           +10.905*exp(-0.61893*rig) )
            if(chi2_nt(1).gt.chicut.or.chi2_nt(1).lt.0)goto 100 !next event
*     - cut on number of cluster out of the track (noise)
*      (no constraints on the last plane becouse of the 
*       back-scattering from calorimeter)
c$$$            do ip=1,5           !6
c$$$               nclstot=nclsx(ip)+nclsy(ip)
c$$$               if(nclstot.ge.1)goto 100 !next event
c$$$            enddo
            nclstot = 0
            do isx=1,nclsx
c               if(planex(isx).ne.6)nclstot =  nclstot +1
               nclstot =  nclstot +1
            enddo
            do isy=1,nclsy
c               if(planey(isy).ne.6)nclstot =  nclstot +1
               nclstot =  nclstot +1
            enddo
            if(nclstot.ne.0)print*,'iev ',iev,' ncls ',nclstot
c            if(nclstot.ge.1)goto 100 
*     ==================================
*     //////////////////////////////////
*     Track selection (end)
*     \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*     ==================================

            call HCDIR('//LEVEL2',' ')
                        
            goodtr = goodtr +1
            nselect = nselect +1
c            print*,goodtr,' ****',iev
            call HFNT(ntp_level2) !fill LEVEL2 nt-uple         
            

            call HCDIR('//PAWC','')

*     -----------------------------------------------------
*     +++++++++++++++++++++++++++++++++++++++++++++++++++++
*     calibrations (sum over events)
*     +++++++++++++++++++++++++++++++++++++++++++++++++++++
*     -----------------------------------------------------

            if(goodtr.lt.ncorrmax)then
               do ip=1,nplanes  !1-->6
                  
                  iviewx = (nplanes - ip)*2+2 !12-->2
                  ilx=nld(maxs(which_cl_x(ip)),iviewx)
                  iviewy = (nplanes - ip)*2+1 !11-->1
                  ily=nld(maxs(which_cl_y(ip)),iviewy)
                  if(ilx.ne.ily)print*,'LADDERS DO NOT MATCH!!!'
                                    
                  chargexy(ip,ilx,goodtr,1)=dedx(which_cl_x(ip))
                  chargexy(ip,ily,goodtr,2)=dedx(which_cl_y(ip))
                  
               enddo
            endif
*     compute average amgle in each bin
            do i=1,nviews
               do ia=1,nangbin
                  if(navangbin(ia,i).ne.0)
     $                 avangbin(ia,i)=
     $                 avangbin(ia,i)/navangbin(ia,i)
               enddo
            enddo

*     apply a cut on the measured rigidity:
            if(rig.gt.rigmax)then
               call fill_eta_histos
               call fill_check_histos
            endif
            
*     -----------------------------------------------------
*     +++++++++++++++++++++++++++++++++++++++++++++++++++++
*     calibrations (end)
*     +++++++++++++++++++++++++++++++++++++++++++++++++++++
*     -----------------------------------------------------
 100        continue

         enddo                  !end loop on events             

         
         print*,''
         print *,'- Stored ',nselect,' entries in LEVEL2 nt-uple'
         call HCDIR('//LEVEL1',' ')
         call HREND('level1')
         close(lun_data_level1) 

         call HCDIR('//PAWC',' ')
         call HDELET(ntp_level1+20)

      enddo                     !end loop on files

      print*,''
      call HCDIR('//LEVEL2',' ')
      call RZPURG(-1)    
      call HROUT(ntp_level2,ICYCLE,'T')
      call HREND('level2')
      close(lun_data_level2)

      call HCDIR('//PAWC',' ')
      call HDELET(ntp_level2)


*     ===================================================
*     in the following the charge correlation parameters
*     and the eta correction functions are evaluated
*     and stored in txt files.
*     However I chosed to do it "off-line", by means of 
*     a kumac, so that I can group more files together.
*     ===================================================

*     -----------------------------------------------------
*     +++++++++++++++++++++++++++++++++++++++++++++++++++++
*     calibrations
*     +++++++++++++++++++++++++++++++++++++++++++++++++++++
*     -----------------------------------------------------

      do il=1,3
         write(rzdir,1010)il
**************************************************
**************************************************
*     CHARGE CORRELATION CALIBRATION
**************************************************
**************************************************
         if(DONTDO)goto 8881
         call charge_calibration(il)
 107     format(/
     $        ,/
     $        ,/
     $        ' >>> CHARGE-CORRELATION CALIBRATION <<<',/
     $        ,/
     $        'Save charge correlation parameters --->',/
     $        ,a,/
     $        ,/
     $        ,'Parameterization ------>  Sy = K * Sx + C',/
     $        ,'Plane        K       EK        C       EC',/
     $        ,'-----------------------------------------')
c     write(lun_file_log,107)file_out(1:LNBLNK(file_out))
         
         file_out=
     $        out_dir(1:LNBLNK(out_dir))//'trk-'
     $        //rzdir//'-charge.dat'
         write(*,107)file_out(1:LNBLNK(file_out))
         open(55,
     $        FILE=file_out(1:LNBLNK(file_out)),
c     $     STATUS='NEW',
     $        FORM='FORMATTED')
         
 108     format(i5,4f9.5)
         do ip=1,nplanes
c            write(lun_file_log,108) !log file
c     $           ip,syksx(ip),esyksx(ip),sycsx(ip),esycsx(ip)
            write(*,108)        !screen
     $           ip,syksx(ip),esyksx(ip),sycsx(ip),esycsx(ip)
            write(55,*)         !data
     $           ip,syksx(ip),esyksx(ip),sycsx(ip),esycsx(ip) 
         enddo
         close(55)
         
 8881    call fill_charge_histos(il)
**************************************************
**************************************************
*     ETA CALIBRATION
**************************************************
**************************************************
         file_out=
     $        out_dir(1:LNBLNK(out_dir))//'trk-'
     $        //rzdir
         
 109     format('Creating files:',/
     $        ,' ',a,'-eta2-binning.dat',/
     $        )
         write(*,109)file_out(1:LNBLNK(file_out))
         open(lun_file_eta,
     $        FILE=file_out(1:LNBLNK(file_out))//'-eta2-binning.dat'
     $        ,FORM='FORMATTED'
     $        )
         do ia=1,nangbin
            write(lun_file_eta,*)ia,angL(ia),angR(ia)
         enddo
         close(lun_file_eta)
      

         if(DONTDO)goto 8882
         do ia=1,nang

 201        format('-eta2-bin',i1,'.dat')
 202        format('-eta2-bin',i2,'.dat')
            if(ia.lt.10)write(fname_param,201)ia
            if(ia.ge.10)write(fname_param,202)ia
            
            open(lun_file_eta,
     $           FILE=file_out(1:LNBLNK(file_out))
     $           //fname_param(1:LNBLNK(fname_param))
     $           ,FORM='FORMATTED'
     $           )
            
            call eta_calibration(il,ia)
            
*     ********************** write **************************
 203        format(13f10.4)
            do ie=1,nhbin2+1
               write(lun_file_eta,203)
     $              eta2abs(ie),(eta2corr(ie,i),i=1,nviews)
            enddo   
            close(lun_file_eta)
*     ********************** write **************************
            
         enddo                  !end loop on angular bins
 8882    continue
         
      enddo                     !end loop on LADDERs

*     -----------------------------------------------------
*     +++++++++++++++++++++++++++++++++++++++++++++++++++++
*     calibrations
*     +++++++++++++++++++++++++++++++++++++++++++++++++++++
*     -----------------------------------------------------
 8888 continue


c------------------------------------------------------------------------
c     
c     no error exit
c     
c------------------------------------------------------------------------

      goto 9000                 !happy ending


c------------------------------------------------------------------------
c     
c     data file opening error
c     
c------------------------------------------------------------------------
 19   continue
      
      print*,' '
      print*,'ERROR OPENING DATA FILE: ',data_file
      print*,' '
      print*,' '
      
      goto 9000                 !the end

c------------------------------------------------------------------------
c     
c     level1 ntuple event reading error
c     
c------------------------------------------------------------------------
      
 21   continue
      
      print*,' '
      print*,'ERROR WHILE READING LEVEL1 NTUPLE, AT EVENT
     $     : ',iev
      print*,' '
      print*,' '
      
      goto 9000                 !the end

c------------------------------------------------------------------------
c     
c     calib file opening error
c     
c------------------------------------------------------------------------
      
 17   continue
      
      print*,' '
      print*,'preanalysis: ERROR OPENING INPUT FILE: ',data_file_calib
      print*,' '
      print*,' '
      
      goto 9000                 !the end

 16   continue
      
      print*,' '
      print*,'preanalysis: ERROR OPENING OUTPUT FILE: ',file_out
      print*,' '
      print*,' '
      
      goto 9000                 !the end

c------------------------------------------------------------------------
c     
c     closes files and exits
c     
c------------------------------------------------------------------------

 9000 continue
      
c$$$      if(DEBUG)call HPRNTU(ntp_level2+1)
c$$$      call HPRNTU(ntp_level2)
c$$$      print*,''
c$$$      call HCDIR('//LEVEL2',' ')
c$$$      call HROUT(ntp_level2,ICYCLE,'T')
c$$$      print *,'- Stored LEVEL2 nt-uple (',nev2,' entries )'
c$$$      if(DEBUG)call HROUT(ntp_level2+1,ICYCLE,'T')
c$$$      if(DEBUG)print *,'- Stored DEBUG nt-uple '
c$$$      call HREND('level2')
c$$$      close(lun_data_level2)

c$$$      call HCDIR('//LEVEL1',' ')
c$$$      call HREND('level1')
c$$$      close(lun_data_level1)

      write(*,105)
     $     tottr
     $     ,goodtr
 105  format(/
     $     ,/
     $     ,'|------------------------------------------------|',/
     $     ,'|  Number of processed events                    |',/
     $     ,'|  Total         ',i8,'                        |'/
     $     ,'|  Good tracks   ',i8,'                        |'/
     $     ,'|------------------------------------------------|',/
     $     )
      
      
      
      do ilad=1,3
         write(rzdir,1010)ilad
         
         call HCDIR('//PAWC/'//rzdir,' ')
         call HCDIR('//'//RZDIR,' ')
         
         call HROUT(id_hi_chi,ICYCLE,'T')
         call HROUT(id_hi_chi+100,ICYCLE,'T')
         call HROUT(id_hi_chi+200,ICYCLE,'T')
         call HROUT(id_hi_rig,ICYCLE,'T')
         call HROUT(id_hi_charge,ICYCLE,'T')
         do i=1,nviews
            call HROUT(id_hi_charge+i*100,ICYCLE,'T')
            call HROUT(id_hi_charge+i*100+1,ICYCLE,'T')
            call HROUT(id_hi_charge+i*100+2,ICYCLE,'T')
            call HROUT(80000+id_hi_charge+i*100+2,ICYCLE,'T')
            call HROUT(id_hi_mult+i*100,ICYCLE,'T')
            call HROUT(80000+id_hi_mult+i*100,ICYCLE,'T')
            do ia=1,nang
               call HROUT(id_hi_eta2+i*100+ia,ICYCLE,'T')
               call HROUT(id_hi_eta3+i*100+ia,ICYCLE,'T')
               call HROUT(id_hi_eta4+i*100+ia,ICYCLE,'T')
c               call HROUT(id_hi_charge+i*100+ia,ICYCLE,'T')
               call HROUT(id_hi_mult+i*100+ia,ICYCLE,'T')
               call HROUT(id_hi_mult+i*100+ia+50000,ICYCLE,'T')
            enddo            
c     call HROUT(id_hi_chi+100+ia,ICYCLE,'T')
c     call HROUT(id_hi_chi+200+ia,ICYCLE,'T')
         enddo
         do ip=1,nplanes
            call HROUT(id_hi_angle+100+ip,ICYCLE,'T')
            call HROUT(id_hi_angle+200+ip,ICYCLE,'T')
            call HROUT(id_hi_angle_stat+100+ip,ICYCLE,'T')
            call HROUT(id_hi_angle_stat+200+ip,ICYCLE,'T')
            call HROUT(id_hi_chargeco+ip*100+4,ICYCLE,'T')
            call HROUT(id_hi_chargeco+ip*100,ICYCLE,'T')
            do is=1,2
               call HROUT(id_hi_beam+ip*100+is+200000,ICYCLE,'T')
               call HROUT(id_hi_beam+ip*100+is+100000,ICYCLE,'T')
            enddo
            call HROUT(id_hi_bx+ip,ICYCLE,'T')
            call HROUT(id_hi_by+ip,ICYCLE,'T')
            call HROUT(id_hi_bz+ip,ICYCLE,'T')
         enddo
         
         call HREND(RZDIR)
         close(lun_file_out+ilad)
         
      enddo
      
     




      stop
      end


# include "momanhough-subroutines.F"


****** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * ******
******* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *******
****** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * ******
******* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *******
****** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * ******
******* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *******
****** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * ******
******* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *******
****** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * ******
******* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *******
****** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * ******
******* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *******

***************************************************************
*
*
*
*
*
***************************************************************
      subroutine book_eta_histos

      include '../common/commontracker.f'
      include '../common/calib.f'
      include '../common/common_calibration.f'  

      character*64 title        !histos title

 502  format('Eta-2 (view ',i2,', angle bin ',i2,' )')
 503  format('Eta-3 (view ',i2,', angle bin ',i2,' )')
 504  format('Eta-4 (view ',i2,', angle bin ',i2,' )')
      
      do i=1,nviews
         do ia=1,nangbin
            write(title,502)i,ia
            call HBOOK1(id_hi_eta2+i*100+ia
     $           ,title
c     $           ,nhbin2,0.,1.,0.)
     $           ,nhbin2,-0.5,0.5,0.)
            write(title,503)i,ia
            call HBOOK1(id_hi_eta3+i*100+ia
     $           ,title
c     $           ,nhbin3,0.,2.,0.)
     $           ,nhbin2,-0.5,0.5,0.)
            write(title,504)i,ia
            call HBOOK1(id_hi_eta4+i*100+ia
     $           ,title
c     $           ,nhbin4,0.,3.,0.)
c     $           ,nhbin3,-1.,1.,0.)
     $           ,nhbin3,-0.5,.5,0.)
         enddo            
      enddo


      return
      end
C............................................................
      subroutine fill_eta_histos

      include '../common/commontracker.f'
      include '../common/calib.f'
      include '../common/common_calibration.f'
      include '../common/level1.f'
      include '../common/level2.f'

      character*10 rzdir

*     flag to tag low-multilpicity cluster
*     (according to Samu definition)
      logical LMSX,LMSY,DRAY


 10   format('LADDER',i1)
*     start loop on planes to fill histos
      do ip=1,nplanes           !1-->6

*---------------------------------------------------------
*     main x-y cluster parameters
*---------------------------------------------------------
         xxx = xm_nt(ip,1)
         yyy = ym_nt(ip,1)
         call whichsensor(ip,xxx,yyy,iladder,isensor)
         if(iladder.eq.0.or.isensor.eq.0)then            
            goto 10102
         endif

         multx = mult(which_cl_x(ip))
         multy = mult(which_cl_y(ip))
         thetax = axv_nt(ip,1) 
         thetay = ayv_nt(ip,1) 
         LMSX=.false.
         LMSY=.false.
*     ===============================================
*     multiplicity selection of SAMUELE
c$$$         if(
c$$$     $        (thetax.le.15..and.multx.le.2).or.
c$$$     $        (thetax.gt.15..and.multx.le.3).or.
c$$$     $        .false.)LMSX=.true.
c$$$         if(
c$$$     $        (multx.le.2).or.
c$$$     $        .false.)LMSY=.true.
*     ===============================================
*     looser cut ... after LANDI warning
*     (I also require that both clx anc cly are low-multiplicity)
         if(
     $   (abs(thetax).le.10..and.multx.le.3).or.
     $  ((abs(thetax).gt.10..and.abs(thetax).le.15.).and.multx.le.4).or.
     $   (abs(thetax).gt.15..and.multx.le.5).or.
     $        .false.)LMSX=.true.
         if(
     $        (multy.le.3).or.
     $        .false.)LMSY=.true.


*     charge scaling factor (to vertical trajectory)
         pi=acos(-1.)
         fact=
     $        sqrt( 
     $        tan(pi*thetax/180.)**2 + 
     $        tan(pi*thetay/180.)**2 + 
     $        1. 
     $        )
         dedxscalx = dedx(which_cl_x(ip)) / fact
         dedxscaly = dedx(which_cl_y(ip)) / fact
         dedxscal = (dedxscalx+dedxscaly)/2
 
         DRAY=.false.
         if(dedxscal.gt.dedxmax)DRAY=.true.

*---------------------------------------------------------


         write(rzdir,10)iladder
         call HCDIR('//'//rzdir,'')
         call HCDIR('//PAWC/'//rzdir,'')

*---------------------------------------------------------
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*                      X VIEWS
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*---------------------------------------------------------

         if(  thetax.lt.angL(1).or.
     $        thetax.ge.angR(nangbin).or.
     $        .not.LMSX.or.
     $        .not.LMSY.or.
     $        DRAY.or.
     $        .false.)goto 10101 ! skip
         
         iview = (nplanes - ip)*2+2 !12-->2
         e2=cog(2,which_cl_x(ip))
         e3=cog(3,which_cl_x(ip))
         e4=cog(4,which_cl_x(ip))
         do ia=1,nangbin            
            if (thetax.lt.angR(ia))goto 111
         enddo
 111     ibin_ang = ia          !angular bin

         avangbin(ibin_ang,iview)=avangbin(ibin_ang,iview)+thetax
         navangbin(ibin_ang,iview)=navangbin(ibin_ang,iview)+1

*!!!!!!!!NB non sempre MAXS coincide con la strip massima !!!!
         if(e2.ge.0.5)e2=e2-1.
         if(e2.lt.-0.5)e2=e2+1.
         if(e3.ge.0.5)e3=e3-1.
         if(e3.lt.-0.5)e3=e3+1.
c         if(e4.ge.1.)e4=e4-2.
c         if(e4.lt.-1.)e4=e4+2.
         if(e4.ge.0.5)e4=e4-1.
         if(e4.lt.-0.5)e4=e4+1.
*!!!!!!!!NB

         if(e2.ne.0.)
     $        call hfill(id_hi_eta2+iview*100+ibin_ang,
     $        e2,0.,1.)
         if(e3.ne.0.)
     $        call hfill(id_hi_eta3+iview*100+ibin_ang,
     $        e3,0.,1.)
         if(e4.ne.0.)
     $        call hfill(id_hi_eta4+iview*100+ibin_ang,
     $        e4,0.,1.)

10101    continue
         
*---------------------------------------------------------
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*                      Y VIEWS
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*---------------------------------------------------------
         if(  thetay.lt.angL(1).or.
     $        thetay.ge.angR(nangbin).or.
     $        .not.LMSY.or.
     $        .not.LMSX.or.
     $        DRAY.or.
     $        .false.)goto 10102 !skip
         
         iview = (nplanes - ip)*2+1 !11-->1
         e2=cog(2,which_cl_y(ip))
         e3=cog(3,which_cl_y(ip))
         e4=cog(4,which_cl_y(ip))
         do ia=1,nangbin            
c            if (thetay.lt.(ang(ia)+angstep/2.))goto 112
c            if (thetay.lt.angbin(ia))goto 112
            if (thetay.lt.angR(ia))goto 112
         enddo
 112     ibin_ang = ia

         avangbin(ibin_ang,iview)=avangbin(ibin_ang,iview)+thetay
         navangbin(ibin_ang,iview)=navangbin(ibin_ang,iview)+1
c         print*,'****',avangbin(ibin_ang,iview),thetay


*!!!!!!!!NB non sempre MAXS coincide con la strip massima !!!!
         if(e2.gt.0.5)e2=e2-1.
         if(e2.lt.-0.5)e2=e2+1.
         if(e3.ge.0.5)e3=e3-1.
         if(e3.lt.-0.5)e3=e3+1.
c         if(e4.ge.1.)e4=e4-2.
c         if(e4.lt.-1.)e4=e4+2.
         if(e4.ge.0.5)e4=e4-1.
         if(e4.lt.-0.5)e4=e4+1.
*!!!!!!!!NB

         if(e2.ne.0.)
     $        call hfill(id_hi_eta2+iview*100+ibin_ang,
     $        e2,0.,1.)
         if(e3.ne.0.)
     $        call hfill(id_hi_eta3+iview*100+ibin_ang,
     $        e3,0.,1.)
         if(e4.ne.0.)
     $        call hfill(id_hi_eta4+iview*100+ibin_ang,
     $        e4,0.,1.)

10102    continue
      enddo
      call HCDIR('//PAWC','')
      return

      end

C............................................................
      subroutine book_charge_histos

      include '../common/commontracker.f'
      include '../common/calib.f'  
      include '../common/common_calibration.f'

      character*64 title        !histos titleinfo -f g77 M LEX

c 500  format('Charge correlation (ladder ',i1,' plane ',i2,')')
 500  format('Charge correlation ( plane ',i2,')')
 501  format('Charge residuals ( plane',i2,')')
      
      do ip=1,nplanes
         write(title,500)ip
         call HBOOK2(id_hi_chargeco+ip*100+4
     $           ,title
     $           ,200,0.,1000.
     $        ,200,0.,1000.,0.)
         write(title,501)ip
         call HBOOK1(id_hi_chargeco+ip*100
     $        ,title
     $        ,200,-100.,100.,0.)
      enddo



      return
      end
C............................................................
      subroutine fill_charge_histos(iladder)

      include '../common/commontracker.f'
      include '../common/calib.f'  
      include '../common/common_calibration.f'
      include '../common/level1.f'
      include '../common/level2.f'
*     start loop on planes

c      parameter (ncorrmax=20000)
c      real chargexy(nplanes,ncorrmax,2)
c      integer whichplane,goodtr
c      common/chargecorr/chargexy,whichplane,goodtr

      character*10 rzdir

 1010 format('LADDER',i1)
      write(rzdir,1010)iladder
      call HCDIR('//'//rzdir,'')
      call HCDIR('//PAWC/'//rzdir,'')
      
      do ip=1,nplanes           !1-->6
         
         do ie=1,min(goodtr,ncorrmax)
            
            sx = chargexy(ip,iladder,ie,1)
            sy = chargexy(ip,iladder,ie,2)
            
            if(sx.ne.0..and.sy.ne.0)then

               call HFILL(id_hi_chargeco+ip*100+4,sx,sy,1.) 
               d= sy - syksx(ip)*sx - sycsx(ip)
               d=d/sqrt(syksx(ip)**2+1)          
               call HFILL(id_hi_chargeco+ip*100,
     $              d,0.,1.)
            
            endif
            
         enddo
      enddo

      return
      end
C............................................................

      subroutine book_check_histos
*
*     some histos to check the sample tracks
*     and define quality cuts
*
      include '../common/commontracker.f'
      include '../common/calib.f'
      include '../common/common_calibration.f'  

      character*64 title        !histos title
      real xbins(nangbin+1)

      parameter (nrigbin=500)
      real xrigbin(nrigbin+1)

* * * * * * * * * * * * * * * * * * * * * * * *
*     CHI**2 + RIGIDITY


      rmin=0.2
      rmax=1000.
      step=abs(log10(rmin)-log10(rmax))/nrigbin
      xrigbin(1)=rmin
      do i=2,nrigbin+1
         xrigbin(i)=10**(log10(xrigbin(i-1))+step)
*         print*,'### ',i,xrigbin(i-1),xrigbin(i)
      enddo
      call HBOOKB(id_hi_rig
     $     ,'Rigidity'
     $     ,nrigbin,xrigbin,0.)


      call HBOOK1(id_hi_chi
     $     ,'Chi**2'
     $     ,1000,0.,100.,0.)
      call HBPROF(id_hi_chi+100
     $     ,'Chi**2 vs Rigidity'
     $     ,150,rmin,0.1*rmax,0.,100.,0.)
      call HBPROF(id_hi_chi+200
     $     ,'Chi**2 vs Angle x'
     $     ,50,0.,25.,0.,100.,0.)

      
*     * * * * * * * * * * * * * * * * * * * * * * *
*     ANGLE

      nbin=200.
      from=angL(1)!angbin(1)
      to=angR(nangbin)!angbin(nang+1)   
      do ip=1,nplanes
         call HBOOK1(id_hi_angle+100+ip
     $        ,'Angle (Y view)'
     $        ,nbin,from,to,0.)
         call HBOOK1(id_hi_angle+200+ip
     $        ,'Angle (X view)'
     $        ,nbin,from,to,0.)
         
c$$$         call HBOOK1(id_hi_angle_stat+100+ip
c$$$     $        ,'Angle (Y view)'
c$$$     $        ,nangbin,from,to,0.)
c$$$         call HBOOK1(id_hi_angle_stat+200+ip
c$$$     $        ,'Angle (X view)'
c$$$     $        ,nangbin,from,to,0.)

         xbins(1)=angL(1)
         do i=1,nangbin
            xbins(i+1)=angR(i) 
         enddo
         call HBOOKB(id_hi_angle_stat+100+ip
     $        ,'Angle (Y view)'
     $        ,nangbin,XBINS,0.)
         call HBOOKB(id_hi_angle_stat+200+ip
     $        ,'Angle (X view)'
     $        ,nangbin,XBINS,0.)
      enddo


*     * * * * * * * * * * * * * * * * * * * * * * *
*     MULTIPLICITY
 511  format('Multiplicity (view ',i2,', angle bin ',i2,' )')
 512  format('Multiplicity vs angle (view ',i2,' )')
      
      do i=1,nviews
         do ia=1,nangbin
            write(title,511)i,ia
            call HBOOK1(id_hi_mult+i*100+ia
     $           ,title
     $           ,10,0.5,10.5,0.)
         enddo            
         write(title,512)i
         call HBOOK2(id_hi_mult+i*100
     $        ,title
     $        ,50,0.,25.,10,0.5,10.5,0.)
         call HBOOK2(80000+id_hi_mult+i*100
     $        ,title
     $        ,50,0.,25.,10,0.5,10.5,0.)
      enddo
*     * * * * * * * * * * * * * * * * * * * * * * *
*     AVERAGE CLUSTER
 510  format('Average cluster (view ',i2,', angle bin ',i2,' )')

      do i=1,nviews
         do ia=1,nangbin
            write(title,510)i,ia
            call HBOOK1(id_hi_mult+i*100+ia+50000
     $           ,title
     $           ,int(2*nhside+1)
     $           ,-(float(nhside)+0.5),(float(nhside)+0.5),0.)
         enddo            
      enddo


* * * * * * * * * * * * * * * * * * * * * * * *
*     CHARGE
      
 5111 format('dE/dX scaled to 300 micron (view ',i2,' )')
 5112 format('dE/dX vs R (view ',i2,' )')
 5113 format('dE/dX vs multiplicity (view ',i2,' )')
      do i=1,nviews
         write(title,5111)i
         call HBOOK1(id_hi_charge+i*100
     $        ,title
     $        ,500,0.,1000.,0.)
         write(title,5112)i
         call HBPROF(id_hi_charge+i*100+1
     $        ,title
     $        ,1000,0.,100.,0.,1000.,0.)
         write(title,5113)i
         call HBOOK2(id_hi_charge+i*100+2
     $        ,title
     $        ,100,0.,1000.,10,0.5,10.5,0.)
         call HBOOK2(80000+id_hi_charge+i*100+2
     $        ,title
     $        ,100,0.,1000.,10,0.5,10.5,0.)
      enddo
      call HBOOK1(id_hi_charge
     $     ,'dE/dX scaled to 300 micron AVERAGE'
     $     ,500,0.,1000.,0.)

* * * * * * * * * * * * * * * * * * * * * * * *
*     EVENT SPATIAL DISTRIBUTION

51111 format('Strip Y (plane ',i2,', sensor ',i1,')')
51112 format('Strip X (plane ',i2,', sensor ',i1,')')
      do ip=1,nplanes
         do is=1,2
            write(title,51111)ip,is
            call HBOOK1(id_hi_beam+ip*100+is+100000
     $           ,title
     $           ,256,0.5,3072.5,0.)
            write(title,51112)ip,is
            call HBOOK1(id_hi_beam+ip*100+is+200000
     $           ,title
     $           ,256,0.5,3072.5,0.)
         enddo
      enddo

* * * * * * * * * * * * * * * * * * * * * * * *
*     MAGNETIC FIELD

 61   format('Bx (plane ',i2,')')
 62   format('By (plane ',i2,')')
 63   format('Bz (plane ',i2,')')
      do ip=1,nplanes
         write(title,61)ip
         call HBOOK1(id_hi_bx+ip
     $        ,title
     $        ,1000,-5.,5.,0.)
         write(title,62)ip
         call HBOOK1(id_hi_by+ip
     $        ,title
     $        ,1000,-5.,5.,0.)
         write(title,63)ip
         call HBOOK1(id_hi_bz+ip
     $        ,title
     $        ,1000,-5.,5.,0.)
      enddo



      return
      end
C............................................................
      subroutine fill_check_histos

      include '../common/commontracker.f'
      include '../common/calib.f'  
      include '../common/common_calibration.f'
      include '../common/common_mech.f'
      include '../common/level1.f'
      include '../common/level2.f'

      real v(3),b(3)
      character*10 rzdir

      real clusterx(2*nhside+1)
      real clustery(2*nhside+1)
      logical DRAY,LMSX,LMSY

*---------------------------------------------------------
*     track info parameters
*---------------------------------------------------------
      rig = abs(1./al_nt(5,1))
      chi = chi2_nt(1)



 1010 format('LADDER',i1)

*     i plot della rigidita` del chi2
*     non dipendono dal ladder...
      do il=1,3
         write(rzdir,1010)il
         call HCDIR('//'//rzdir,'')
         call HCDIR('//PAWC/'//rzdir,'')
         call HFILL(id_hi_chi,chi,0.,1.)
         call HFILL(id_hi_rig,rig,0.,1.)
         thetax = axv_nt(1,1) 
         thetay = ayv_nt(1,1) 
         call HFILL(id_hi_chi+100,chi,rig,1.)
         call HFILL(id_hi_chi+200,chi,thetax,1.)

      enddo
      
      dedxscalav   = 0
      npdedxscalav = 0
*     start loop on planes
      do ip=1,nplanes           !TOP-->BOTTOM
*---------------------------------------------------------
*     main x-y cluster parameters
*---------------------------------------------------------
         iviewx = nviewx(7-ip)
         iviewy = nviewy(7-ip)
         xxx = xm_nt(ip,1)
         yyy = ym_nt(ip,1)
         call whichsensor((7-ip),xxx,yyy,iladder,isensor)
         if(iladder.eq.0.or.isensor.eq.0)then            
            print*,'*** out *** ',ip,xxx,yyy,iladder,isensor
            goto 10101
         endif
         multx = mult(which_cl_x(ip))
         multy = mult(which_cl_y(ip))
         thetax = axv_nt(ip,1) 
         thetay = ayv_nt(ip,1) 
*     ===============================================
*     looser multiplicity cut ... after LANDI warning
*     (I also require that both clx anc cly are low-multiplicity)
         LMSX=.false.
         LMSY=.false.
         if(
     $   (abs(thetax).le.10..and.multx.le.3).or.
     $  ((abs(thetax).gt.10..and.abs(thetax).le.15.).and.multx.le.4).or.
     $   (abs(thetax).gt.15..and.multx.le.5).or.
     $        .false.)LMSX=.true.
         if(
     $        (multy.le.3).or.
     $        .false.)LMSY=.true.

*     charge scaling factor (to vertical trajectory)
         pi=acos(-1.)
         fact=
     $        sqrt( 
     $        tan(pi*thetax/180.)**2 + 
     $        tan(pi*thetay/180.)**2 + 
     $        1. 
     $        )
         dedxscalx = dedx(which_cl_x(ip)) / fact
         dedxscaly = dedx(which_cl_y(ip)) / fact         
         dedxscal = (dedxscalx+dedxscaly)/2     
         DRAY=.false.
         if(dedxscal.gt.dedxmax)DRAY=.true.
    
         if(.not.DRAY.and.LMSX.and.LMSX)then
            dedxscalav = dedxscalav + dedxscal
            npdedxscalav = npdedxscalav + 1
         endif



         ista  = indstart(which_cl_x(ip))
         ice   = indmax(which_cl_x(ip))
         ilast = totCLlength
         if(which_cl_x(ip).ne.nclstr1)
     $        ilast = indstart(which_cl_x(ip)+1)-1
         do i = -nhside,nhside
            ii = ice + i
            iii=i+nhside+1
            clusterx(iii) = 0
            if(ii.le.ilast.and.ii.ge.ista)
     $           clusterx(iii) = clsignal(ii) / dedx(which_cl_x(ip))
         enddo

         ista  = indstart(which_cl_y(ip))
         ice   = indmax(which_cl_y(ip))
         ilast = totCLlength
         if(which_cl_y(ip).ne.nclstr1)
     $        ilast = indstart(which_cl_y(ip)+1)-1
         do i = -nhside,nhside
            ii = ice + i
            iii=i+nhside+1
            clustery(iii) = 0
            if(ii.le.ilast.and.ii.ge.ista)
     $           clustery(iii) = clsignal(ii) / dedx(which_cl_y(ip))
         enddo

*---------------------------------------------------------

         write(rzdir,1010)iladder
         call HCDIR('//'//rzdir,'')
         call HCDIR('//PAWC/'//rzdir,'')


 
*---------------------------------------------------------
*     find the angular bins (ibin_angy ibin_angx)  
*     associated to the track intersection point with plane ip
*---------------------------------------------------------
         ia=0
         if(  thetax.lt.angL(1).or.
     $        thetax.ge.angR(nangbin))goto 111         
         do ia=1,nangbin            
            if (thetay.lt.angR(ia))goto 111
         enddo
 111     ibin_angy = ia

         ia=0
         if(  thetay.lt.angL(1).or.
     $        thetay.ge.angR(nangbin))goto 112
         do ia=1,nangbin            
            if (thetax.lt.angR(ia))goto 112
         enddo
 112     ibin_angx = ia



*---------------------------------------------------------
*     fill histos
*---------------------------------------------------------

************************************************ ANGLE      

         call HFILL(id_hi_angle+200+ip,thetax,0.,1.)
         call HFILL(id_hi_angle+100+ip,thetay,0.,1.)
      
         call HFILL(id_hi_angle_stat+200+ip,thetax,0.,1.)
         call HFILL(id_hi_angle_stat+100+ip,thetay,0.,1.)
         
************************************************ multiplicity & cluster
         if(ibin_angx.ne.0)then
            call HFILL(id_hi_mult+iviewx*100+ibin_angx,
     $           float(mult(which_cl_x(ip))),0.,1.)
            do i=-nhside,nhside
               ii = i + nhside +1
               xxxx=clusterx(ii)
               call HFILL(id_hi_mult+iviewx*100+ibin_angx+50000,
     $              float(i),0.,xxxx)
            enddo
         endif

         if(ibin_angy.ne.0)then
            call HFILL(id_hi_mult+iviewy*100+ibin_angy,
     $           float(mult(which_cl_y(ip))),0.,1.)
            do i=-nhside,nhside
               ii = i + nhside +1
               xxxx=clustery(ii)
               call HFILL(id_hi_mult+iviewy*100+ibin_angy+50000,
     $              float(i),0.,xxxx)
            enddo
         endif

************************************************ charge
         call HFILL(id_hi_charge+iviewx*100,
     $        dedxscalx,0.,1.)         
         call HFILL(id_hi_charge+iviewy*100,
     $        dedxscaly,0.,1.)
         
         call HFILL(id_hi_charge+iviewx*100+1,
     $        rig,dedxscalx,1.)         
         call HFILL(id_hi_charge+iviewy*100+1,
     $        rig,dedxscaly,1.)

*     --------------------------------------------
C     this are the condition applied to select the
C     particle sample for pfa calibration
*     --------------------------------------------
         if(.not.DRAY.and.LMSX.and.LMSY)then
            call HFILL(id_hi_charge+iviewx*100+2,
     $           dedxscalx,float(multx),1.)         
            call HFILL(id_hi_charge+iviewy*100+2,
     $           dedxscaly,float(multy),1.)
            call HFILL(id_hi_mult+iviewx*100,
     $           abs(thetax),float(multx),1.)
            call HFILL(id_hi_mult+iviewy*100,
     $           abs(thetay),float(multy),1.)
         endif
         call HFILL(80000+id_hi_charge+iviewx*100+2,
     $        dedxscalx,float(multx),1.)         
         call HFILL(80000+id_hi_charge+iviewy*100+2,
     $        dedxscaly,float(multy),1.)
         call HFILL(80000+id_hi_mult+iviewx*100,
     $        abs(thetax),float(multx),1.)
         call HFILL(80000+id_hi_mult+iviewy*100,
     $        abs(thetay),float(multy),1.)
         
************************************************ beam profle
         call hfill(id_hi_beam+ip*100+isensor+100000,
     $        float(MAXS(which_cl_y(ip))),0.,1.)
         call hfill(id_hi_beam+ip*100+isensor+200000,
     $        float(MAXS(which_cl_x(ip))),0.,1.)


************************************************ magnetic field

         v(1) = xv_nt(ip,1) 
         v(2) = yv_nt(ip,1) 
         v(3) = zv_nt(ip,1) 

         call gufld(v,b)

         bx=b(1)
         by=b(2)  
         bz=b(3)
         call hfill(id_hi_bx+ip,bx,0.,1.)
         call hfill(id_hi_by+ip,by,0.,1.)
         call hfill(id_hi_bz+ip,bz,0.,1.)

      enddo

      dedxscalav = dedxscalav/npdedxscalav
      call HFILL(id_hi_charge,
     $     dedxscalav,0.,1.)



10101 continue
      call HCDIR('//PAWC','')

      return
      end

***************************************************************************
*
*
*
*
*
*
*
*
*
***************************************************************************


      subroutine FCNcharge(npar,grad,fval,xval,iflag,futil)

      include '../common/commontracker.f'
      include '../common/calib.f'
      include '../common/common_calibration.f'

      double precision grad(*),xval(*),fval
      integer npar,iflag
      double precision KKK,CCC


c      parameter (ncorrmax=20000)
c      real chargexy(nplanes,ncorrmax,2)
c      integer whichplane,goodtr
c      common/chargecorr/chargexy,whichplane,goodtr
      
      KKK=xval(1)
      CCC=xval(2)


      fval = 0.


      sum2=0
      do i=1,min(goodtr,ncorrmax)
         sx=chargexy(whichplane,whichladder,i,1)
         sy=chargexy(whichplane,whichladder,i,2)
*         if(sx.gt.140..and.sy.gt.140)then
            d=(sy-KKK*sx-CCC)**2
            d=d/(KKK**2+1)
            d=d/(1.9*4.**2+1.2*8.**2) !errors
            sum2=sum2+d
c$$$  PRINT*,'xx ',i,d,' sx-sy  '
c$$$     $        ,chargexy(whichplane,whichladder,i,1)
c$$$     $        ,chargexy(whichplane,whichladder,i,2)
*         endif
      enddo


      fval = sum2



      return

      end




**************************************************
**************************************************
*     CHARGE CORRELATION CALIBRATION
**************************************************
**************************************************
      subroutine charge_calibration(iladder)

      include '../common/commontracker.f'
      include '../common/calib.f'  
      include '../common/common_calibration.f'
c      include '../common/common_mech.f'
c      include '../common/level1.f'
c      include '../common/level2.f'
      external FCNcharge

      character*12 chnam
      double precision val,error
      

      do ip=1,nplanes
         print*,' '
         print*,' '
         print*,' '
         print*,
     $        '               -----------------------------------'
         print*,
     $        '////////////// MINUIT for plane ',ip,' - ladder ',iladder
         print*,
     $        '               -----------------------------------'
         open(UNIT=40,FILE=
     $        'bin-aux/data-card.dat'
     $        ,STATUS='OLD')
         call mintio(40,6,7)
         whichplane = ip
         whichladder = iladder
         call minuit(FCNcharge,0)
c     call MNERRS(1,eplus,eminus,eparab,globcc)
         call MNPOUT(1,chnam,val,error,bnd1,bnd2,ivarbl)
         syksx(ip)=val
         esyksx(ip)=error
         call MNPOUT(2,chnam,val,error,bnd1,bnd2,ivarbl)
         sycsx(ip)=val
         esycsx(ip)=error
         close(40)
      enddo      
      
      return
      end

**************************************************
**************************************************
*     ETA CALIBRATION
**************************************************
**************************************************
      subroutine eta_calibration(iladder,ia)
      include '../common/commontracker.f'
      include '../common/calib.f'  
      include '../common/common_calibration.f'

*     --------------------------------------------
*     some local variables for eta correction
      real histo2(nhbin2)
c      real eta2corr(nhbin2+1,nviews) !eta2 correction
c      real eta2abs(nhbin2+1)         !eta2 abscissa
*     --------------------------------------------
      character*64 ctemp
      character*10 rzdir

 1010 format('LADDER',i1)
      write(rzdir,1010)iladder
      call HCDIR('//'//rzdir,'')
      call HCDIR('//PAWC/'//rzdir,'')

      do i=1,nviews
         id=id_hi_eta2+i*100+ia
*     eta2 histogram
         call HUNPAK(id,histo2,' ',0) !eta2 histogram
         call HGIVE(id,ctemp,nx,xmi,xma,ny,ymi,yma,nwt,loc)
         sum=HSUM(id)
c            print*,ctemp,nx,xmi,xma,ny,ymi,yma,nwt,loc
         if(i.eq.1)then
            do ie=0,nx
               eta2abs(ie+1)=xmi+ie*(xma-xmi)/nx
            enddo
         endif
         if(sum.eq.0)then
            do ie=0,nx
               eta2corr(ie+1,i)=eta2abs(ie+1)
            enddo            
            goto 3
         endif
*     ------------------------------------------------------
*     if the histogram contains less than NMIN4ETA2 entries,
*     the correction factor is not calculated
*     CHANGED!!!
*     it is calculated anyway....
*     ------------------------------------------------------
         nmin4eta2 = 200
         if(sum.lt.nmin4eta2)then
c$$$            do ie=0,nx
c$$$               eta2corr(ie+1,i)=eta2abs(ie+1)
c$$$            enddo            
            print*,'*** WARNING ***'
            print*,'ETA2 parameters: less than ',nmin4eta2
     $           ,' entries ----> ',rzdir,' view ',i,' ang. bin ',ia
c$$$            goto 3
         endif
*     integral of the eta2 histogram
         eta2corr(1,i)=0.
         do ie=1,nx
            eta2corr(ie+1,i)=eta2corr(ie,i)+histo2(ie)
         enddo
*     eta2 normalization
         angle=avangbin(ia,i)
         x0=eta2fix(i,angle)    !point of reference for correction function
         do ifix=1,nx+1
            if(eta2abs(ifix).ge.x0)goto 2
         enddo
 2       y0=eta2corr(ifix,i)/sum
c     shift=eta2shift(i,angle)
         shift = 0.
         do ie=0,nx
            eta2corr(ie+1,i)=
     $           x0-y0+eta2corr(ie+1,i)/sum-shift
         enddo     
 3       continue
      enddo                     !end loop on views       
      
      
      
      return
      end
*---***---***---***---***---***---***---***---***
*
*     functions to define the point where to "fix"
*     the eta correction
*     and the shift
*
*---***---***---***---***---***---***---***---***
      function eta2fix(iview,angle)

      if(mod(iview,2).eq.0)then !>>>>>>>> X

         eta2fix = -0.5

      else                      !>>>>>>>> Y

         eta2fix = -0.5

      endif


      return
      end


c$$$      function eta2shift(iview,angle)
c$$$
c$$$      parameter (hallm_e=1650.) !cm**2 / Vs
c$$$      parameter (hallm_h=310.)
c$$$
c$$$      include '../common/commontracker.f'
c$$$      include '../common/common_preanalysis.f'
c$$$      character*32 ctemp
c$$$      real hallm
c$$$
c$$$      pi=acos(-1.)
c$$$
c$$$      np=npl(iview)
c$$$      if(mod(iview,2).eq.0)then !>>>>>>>> X
c$$$         id=id_hi_by+np
c$$$         hallm=hallm_h*1e-4
c$$$      else 
c$$$         id=id_hi_bx+np
c$$$         hallm=hallm_e*1e-4
c$$$      endif
c$$$      bfield=HSTATI(id,1,' ',0)
c$$$      bfield=bfield*1e-1
c$$$      tgth_h=-hallm*bfield
c$$$
c$$$      tgth_eff=tan(pi*angle/180.)-tgth_h
c$$$      theta_eff=atan(tgth_eff)*180./pi
c$$$      if(iview.ne.12)theta_eff=-theta_eff     
c$$$      
c$$$      if(mod(iview,2).eq.0)then !>>>>>>>> X
c$$$         
c$$$         eta2shift = -1.549*sin(2*pi*theta_eff/13.59)         
c$$$         eta2shift = eta2shift/51.
c$$$
c$$$      else                      !>>>>>>>> Y
c$$$         
c$$$         eta2shift = -1.348*sin(2*pi*theta_eff/27.73)         
c$$$         eta2shift = eta2shift/67.
c$$$*     NBNBNBNBNB ... da risolvere il problema della simulazione!!!!
c$$$
c$$$      endif
c$$$
c$$$c      print*,iview,np,bfield,angle,theta_eff,'>>>>>>> ',eta2shift
c$$$
c$$$      return
c$$$      end

*************************************************************************
*     
*     Subroutine cutcn.f!DA COMMENTARE!???
*     
*     excludes strips with particle signals and/or noisy strips from common
*     noise calculation, marking their clstr(nviews,nva1_view,nstrips_va1)
*     flag:
*     clstr=0 ---> not to be used in CN computation
*     clstr=1 ---> to be used in CN computation
*     
*     needs:
*     - ./common_calib.f
*     
*     to be called inside ./cncomp.f
*     
*************************************************************************
      
      subroutine cutcn(i,j)     !(view, VA1)

      include '../common/commontracker.f'
      include '../common/common_reduction.f'
      include '../common/calib.f'


      integer skip              !used to skip strips (see later...)

      integer kr, kl            !position indexes to check signal affected
                                ! strips on right and left side of cluster
                                ! seed
      integer ir, il            !flags to exit loop on reaching VA1 extremes

      real value                !cluster seed signal
      real cut,stripcut         !cluster seed cut

      real valuel, valuer       !left and right strips signal
      real stripcnincut         !strip include cut

      skip = 0                  !initializes skip

      do k=1,nstrips_va1        !loops on strips searching for cluster seeds

         if(k.le.skip) goto 20  !continues only if k strip has not been
                                ! checked yet

         clstr(i,j,k)=1         !reinitializes strip to be used in CN!???
                                ! computation, in order to be able to exclude
                                ! different strips at every CN computation loop

c------------------------------------------------------------------------
c     
c     selects cut according to view
c     
c------------------------------------------------------------------------
         if(mod(i,2).eq.1) then !odd strip ---> Y view
            value= - (DBLE(adc(i,j,k))-cn(i,j)-pedestal(i,j,k)) !negative signal
            cut=clcuty          !sets Y cut to find cluster seeds
         else                   !even strip ---> X view
            value= DBLE(adc(i,j,k))-cn(i,j)-pedestal(i,j,k) !positive signal
            cut=clcutx          !sets X cut to find cluster seeds
         endif


c------------------------------------------------------------------------
c     
c     seeks clusters
c     
c------------------------------------------------------------------------
         stripcut=cut*sigma(i,j,k) !cluster seed cut

c     if(ABS(value).gt.stripcut) then !checks if signal exceeds threshold!???
         if(value.gt.stripcut) then !checks if signal exceeds threshold

c$$$            print*,'cut',i,j,k,value,stripcut,adc(i,j,k),cn(i,j)
c$$$     $           ,pedestal(i,j,k) !???

            clstr(i,j,k)=0      !if so, marks this strip as part of a 
                                ! cluster

c------------------------------------------------------------------------
c     after finding a cluster seed, checks also adiacent strips, and marks 
c     the ones exceeding cnincut
c------------------------------------------------------------------------
            kr=k                !initializes position indexes to be equal to
            kl=k                ! cluster seed position

            ir=0                !initialize flags used to exit from
            il=0                ! inclusion loop

            do while (il.eq.0.or.ir.eq.0) !shifts left and right from
                                ! cluster seed till it finds a strip below
                                ! the threshold, or till it reaches first or 
                                ! last VA1 strip
               kr=kr+1          !position index for strips on right side of 
                                ! cluster seed
               kl=kl-1          !and for left side

c------------------------------------------------------------------------
c     checks for last or first strip
c------------------------------------------------------------------------
               if(kr.gt.nstrips_va1.and.ir.eq.0) then !when index goes 
                  ir=1          ! beyond last VA1 strip, change ir flag in 
                                ! order to "help" exiting from loop
                  skip=nstrips_va1+1 !sets skip beyond last strip: all 
                                ! strips on the right have been included in
                                ! the cluster, so skips all next strips 
                                ! (goto 20 condition is now always true)
               endif

               if(kl.lt.1.and.il.eq.0) then !idem when index goes beyond
                  il=1          ! first strip
               endif

c     P.S.: the "....and.i#.eq.0" term in above conditions is needed. In
c     fact, even if I reach a under-cut strip on the right (so I get ir=1),
c     the "do while loop" continues till such strip will be found on the 
c     left too.
c     Thus kl and kr (! too) keep increasing, and it can happen kr gets
c     greater than nstrips_va1 before kl reaches a under-cut strip. In this
c     case it would pass this "if condition", so setting skip=nstrips_va1+1
c     and skipping right strips never checked, if the "....and.i#.eq.0" term
c     weren't the: instead, including this part it won't pass it
c     because when I found reach the last VA1 strip on the right I set ir=1.
c     (AAAAAAHHHHHHHHH!!!!!!!!!!!)

c------------------------------------------------------------------------
c     marks strips exceeding inclusion cut
c------------------------------------------------------------------------
c     for right strips (kr index)
               if(ir.eq.0) then !if last strip or last over-cut strip has
                                ! not been reached

                  if(mod(i,2).eq.1) then !Y view
                     valuer= - (DBLE(adc(i,j,kr))-cn(i,j) !puts in valuer
     $                    -pedestal(i,j,kr)) ! right strip value
                  else          !X view
                     valuer=DBLE(adc(i,j,kr))-cn(i,j)-pedestal(i,j,kr)
                  endif

                  stripcnincut=cnincut*sigma(i,j,kr) !defines include cut
c     if(ABS(valuer).gt.stripcnincut) then !marks right strip if it !???
                  if(valuer.gt.stripcnincut) then !marks right strip if it 
                     clstr(i,j,kr)=0 !exceedes include cut
c$$$      print*,'inclcut_r',i,j,kr,valuer,stripcnincut
c$$$     $                    ,adc(i,j,kr),cn(i,j),pedestal(i,j,kr) !???
                  else
                     ir=1       !otherwise cluster ends and ir flag =1
                                ! signals it
                     skip=kr    !putting skip=kr, next k to be checked is
                                ! k=kr
                  endif 

               endif

c     for left strips (kl index)
               if(il.eq.0) then !if first strip or last over-cut strip has
                                ! not been reached

                  if (mod(i,2).eq.1) then !Y view
                     valuel= - (DBLE(adc(i,j,kl))-cn(i,j) !puts in valuel
     $                    -pedestal(i,j,kl)) ! left strip value
                  else          !X view
                     valuel=DBLE(adc(i,j,kl))-cn(i,j)-pedestal(i,j,kl)
                  endif

                  stripcnincut=cnincut*sigma(i,j,kl) !defines include cut
c     if(ABS(valuel).gt.stripcnincut) then !marks left strip if it!???
                  if(valuel.gt.stripcnincut) then !marks left strip if it
                     clstr(i,j,kl)=0 !exceedes include cut
c$$$      print*,'inclcut_l',i,j,kl,valuel,stripcnincut
c$$$     $                    ,adc(i,j,kl),cn(i,j),pedestal(i,j,kl) !???
                  else
                     il=1       !otherwise cluster ends and il flag =1
                                ! signals it
                  endif

               endif

            enddo               !ends lateral strips loop

         endif                  !ends cluster seed condition

 20      continue               !comes here if next strip on the right has 
                                ! already been included in a cluster

      enddo                     !ends principal strip loop

      return
      end

*************************************************************************
*     
*     Common calib.f
*     
*     contains CALIB variables definitions
*     
*     to be included in:
*     - ../readraw/readraw.F
*     - ../reduction/reduction.f
*     - ../align/prealign.f
*     
*************************************************************************

c------------------------------------------------------------------------
c     
c     pedestal, sigma and badstrip variables
c     
c------------------------------------------------------------------------

      parameter (id_hi_bad=100) !badstrip histo identifier
      parameter (id_hi_ped=200) !pedestal histo identifier
      parameter (id_hi_sig=300) !sigma histo identifier

      real pedestal(nviews,nva1_view,nstrips_va1) !pedestal value
      real pedestal_t(nviews,nva1_view,nstrips_va1) !pedestal truncated value

      real sigma(nviews,nva1_view,nstrips_va1) !sigma value
      real sigma_t(nviews,nva1_view,nstrips_va1) !sigma truncated value

      integer bad(nviews,nva1_view,nstrips_va1) !bad strip flag matrix
                                ! (bad=0 --> good strip, bad=1 --> bad strip)
                                ! NB this is different in 2003 test with respect
                                ! to previous analysis

      common/pedsigbad/pedestal,pedestal_t,sigma,sigma_t,bad

      parameter (clcutx=7.)     !cluster seed cut 
      parameter (clcuty=7.)
      parameter (incutx=4.)     !cut to include strips in cluster definition
      parameter (incuty=4.)


      parameter (id_hi_mask=400) !mask histo identifier

      integer mask(nviews,nva1_view,nstrips_va1) 
      integer mask_vk(nviews,nva1_view) 

      common/mask/mask,mask_vk


c------------------------------------------------------------------------
c     
c     eta2, eta3, eta4 pfa correction parameters
c     
c------------------------------------------------------------------------
*     angular binning
*     NB the angular binning is defined in common_preanalysis.f
*     here are defined variables to retrieve calibration info 
*     (for processing levels next to 1)
      parameter (nangmax=21)    !maximum number of angular bins
      integer nangbin
      real angL(nangmax),angR(nangmax) !Left and Right bin limits

      parameter (netavalmax=150)   !eta2 points 
      integer netaval
      real eta2(netavalmax,nangmax)
      real feta2(netavalmax,nviews,nladders_view,nangmax)
      real eta3(netavalmax,nangmax)
      real feta3(netavalmax,nviews,nladders_view,nangmax)
      real eta4(netavalmax,nangmax)
      real feta4(netavalmax,nviews,nladders_view,nangmax)

      common/angbinning/nangbin,angL,angR
      common/pfa/netaval,eta2,feta2,eta3,feta3,eta4,feta4

c------------------------------------------------------------------------
c     
c     CHARGE CORRELATION
c     
c------------------------------------------------------------------------

c      parameter (chcut=3.)      !cut to associate two clusters
      parameter (chcut=4.)      !cut to associate two clusters
      real kch(nplanes,nladders_view) !angular coeff
      real cch(nplanes,nladders_view) !const
      real sch(nplanes,nladders_view) !sigma
      common/chargeco/kch,cch,sch
c------------------------------------------------------------------------
c     
c     MIP
c
c     (mip signal, scaled to 300 micron, in ADC channels)
c     
c------------------------------------------------------------------------
      real mip(nviews,nladders_view)
      common/adc2mip/mip

      program main_B


      parameter (NWPAWC=6500000)
      common/PAWC/HMEM(NWPAWC)


      real*8 vv(3),ff(3)

      call HLIMIT(NWPAWC)



      call read_B
      print*,' '
      print*,'FINITA LETTURA CAMPO MAGNETICO'
      print*,' '

      print*,' '
      print*,'x,y,z? (cm)'
      do i=1,3
         read(5,*) vv(i)         !in cm
      enddo
      print*,vv(1),vv(2),vv(3)
      print*,' '
      
      do i=1,3                  !trasformo le coordinate in m per
        vv(i)=vv(i)*0.01        !inter_B.f
      enddo
      
      call inter_B(vv(1),vv(2),vv(3),ff) !coordinate in m, campo in tesla

      print*,' '
      print*,' point (m)',vv
      print*,' B (T)',ff
      print*,' '

      print*,' '
      print*,'   --- THE END ---'
      print*,' '
      print*,' '
      
      stop
      end

      include './read_B.f' !routine che legge il campo misurato
      include './inter_B.f'     !routine che calcola il campo

*************************************************************************
*     
*     Common level1.f
*     
*     contains LEVEL1 ntuple variables definitions
*     
*     to be included in:
*     - ../reduction/reduction.f
*     - ../analysis/analysis.f
*     - !???
*     
*     parameters:
*     - nclstrmax
*     - nclstrp
*     
*************************************************************************


c     EVENT block:
      logical good1             !flag to mark good or noise events
      integer nev1              !level1 event number

c     CPU block (only for ground data):
      integer pkt_type1         !CPU packet type identifier. see http://people.roma2.infn.it/~cpu/HB_list.txt
c     0x12 --> calibration board 0                  
c     0x13 --> calibration board 1              
c     0x10 --> event                            
c     0x30 --> full event for calib special     
c     0x83 --> tracker ALARM (control register) 
      integer pkt_num1          !CPU packet number
      integer obt1              !CPU on-board time
      integer which_calib1      !calibration file identifier. see DW_DATE_NUM_calib.txt file

c     CLUSTER block:
      integer nclstr1           !cluster number
      integer view(nclstrmax)   !view the cluster belongs to
      integer ladder(nclstrmax) !ladder the strip carrying the largest signal 
                                ! value belongs to
      integer maxs(nclstrmax)   !cluster strip carrying the largest signal value
      integer mult(nclstrmax)   !cluster multiplicity
      real dedx(nclstrmax)      !cluster multiplicity
      integer indstart(nclstrmax) !cluster starting point index in clsignal array
      integer indmax(nclstrmax) !cluster maximum point index in clsignal array
      integer totCLlength       !sum of all clusters length (to assign
                                ! dimension to clsignal array)
      real clsignal(maxlength)  !signal values of all strips belonging to clusters

c     CNOISE block:
      real cnev(nviews,nva1_view) !common noise of the event for a certain view and
                                ! VA1
      common/level1_general/good1,nev1
      common/level1_cpu/pkt_type1,pkt_num1,obt1,which_calib1
      common/level1_cluster/nclstr1,view,ladder,maxs,mult,dedx,indstart
     $     ,indmax,totCLlength,clsignal,cnev

*************************************************************************
*     
*     Subroutine read_B.f
*     
*     it calls the subroutines which read the magnetic field maps for
*     the PAMELA spectrometer
*     
*     needs:
*     - ./read_B_inner.f inner map reading subroutine
*     - ./read_B_outer.f outer map reading subroutine
*     
*     to be called before ./inter_B.f (interpolation subroutine)
*     
*************************************************************************

      subroutine read_B

c     call the subroutine which reads the maps of the measurements taken
c     inside the magnetic cavity
      call read_B_inner

c     call the subroutine which reads the maps of the measurements taken
c     outside the magnetic cavity
      call read_B_outer        

      return
      end

      include './read_B_inner.f'
      include './read_B_outer.f' 

*************************************************************************
*     
*     Subroutine inter_B.f
*     
*     it computes the magnetic field in a chosen point x,y,z inside or 
*     outside the magnetic cavity, using a trilinear interpolation of
*     B field measurements (read before by means of ./read_B.f)
*     if the point falls outside the interpolation volume, set the field to 0
*     
*     needs:
*     - ../common/common_B_inner.f common file for the inner magnetic field map
*     - ./inter_B_inner.f common file for the inner magnetic field map
*     - ../common/common_B_outer.f common file for the outer magnetic field map
*     - ./inter_B_outer.f common file for the outer magnetic field map
*     
*     to be called after ./read_B.f (magnetic field map reading subroutine)
*     
*     input: coordinates in m
*     output: magnetic field in T
*     
*************************************************************************

      subroutine inter_B(x,y,z,res) !coordinates in m, magnetic field in T

      implicit double precision (a-h,o-z)
      include '../common/common_B_inner.f'
      include '../common/common_B_outer.f'


c------------------------------------------------------------------------
c     
c     local variables
c     
c------------------------------------------------------------------------

      real*8 x,y,z              !point of interest
      real*8 res(3)             !interpolated B components: res = (Bx, By, Bz)

      real*8 zl,zu
      real*8 resu(3),resl(3)

c------------------------------------------------------------------------
c     
c     set the field outside the interpolation volume to be 0
c     
c------------------------------------------------------------------------

      do ip=1,3
        res(ip)=0.
      enddo


c------------------------------------------------------------------------
c     
c     check if the point falls inside the interpolation volumes
c     
c------------------------------------------------------------------------

*     -----------------------
*     INNER MAP
*     -----------------------
      if(
     $          (x.ge.edgexmin).and.(x.le.edgexmax)
     $     .and.(y.ge.edgeymin).and.(y.le.edgeymax)
     $     .and.(z.ge.edgezmin).and.(z.le.edgezmax)
     $     ) then

        call inter_B_inner(x,y,z,res)
c        print*,'INNER - ',z,res

      endif

*     -----------------------
*     OUTER MAP
*     -----------------------
      if(
     $         ((x.ge.edgeuxmin).and.(x.le.edgeuxmax)
     $     .and.(y.ge.edgeuymin).and.(y.le.edgeuymax)
     $     .and.(z.ge.edgeuzmin).and.(z.le.edgeuzmax))
     $     .or.
     $         ((x.ge.edgelxmin).and.(x.le.edgelxmax)
     $     .and.(y.ge.edgelymin).and.(y.le.edgelymax)
     $     .and.(z.ge.edgelzmin).and.(z.le.edgelzmax))
     $     ) then
         
        call inter_B_outer(x,y,z,res)
c        res(2)=res(2)*10
c        print*,'OUTER - ',z,res

      endif

*     --------------------------------
*     GAP between INNER and OUTER MAPS
*     --------------------------------
      if(
     $          (x.gt.edgexmin).and.(x.lt.edgexmax)
     $     .and.(y.gt.edgeymin).and.(y.lt.edgeymax)
     $     .and.(z.gt.edgezmax).and.(z.lt.edgeuzmin)
     $     )then
         
         zu = edgeuzmin
         zl = edgezmax
         call inter_B_inner(x,y,zl,resu)
         call inter_B_outer(x,y,zu,resl)

         do i=1,3
            res(i) = z  * ((resu(i)-resl(i))/(zu-zl))
     $           + resu(i)
     $           -   zu * ((resu(i)-resl(i))/(zu-zl))
         enddo
c        print*,'GAP U - ',z,res

      elseif(
     $          (x.gt.edgexmin).and.(x.lt.edgexmax)
     $     .and.(y.gt.edgeymin).and.(y.lt.edgeymax)
     $     .and.(z.gt.edgelzmax).and.(z.lt.edgezmin)
     $     ) then
         
        
         zu = edgezmin
         zl = edgelzmax
         call inter_B_inner(x,y,zu,resu)
         call inter_B_outer(x,y,zl,resl)
         
         do i=1,3
            res(i) = z  * ((resu(i)-resl(i))/(zu-zl))
     $           + resu(i)
     $           -   zu * ((resu(i)-resl(i))/(zu-zl))
         enddo
c        print*,'GAP D - ',z,res

      endif

      return
      end


      include './inter_B_inner.f'
      include './inter_B_outer.f'

************************************************************************
*     
*     Common common_reduction.f
*     
*     contains variables used only in the execution of  reduction
*     
*     to be included in:
*     - reduction.f
*     
*     
*************************************************************************

      real adc(nviews,nva1_view,nstrips_va1)
      common/adc_value/adc

c------------------------------------------------------------------------
c     
c     common noise computation
c     
c------------------------------------------------------------------------
      parameter (scut=3.)

      real cn(nviews,nva1_view) !common noise value
      integer clstr(nviews,nva1_view,nstrips_va1) !flag matrix to mark 
                                ! strips with signal and exclude them from
                                ! common noise computation
      integer strange(nviews,nva1_view,nstrips_va1) !flag matrix to mark 
                                ! strips with unusually high or low signal and
                                ! exclude them from common noise computation

      common/cn/cn,clstr,strange


c------------------------------------------------------------------------
c     
c     cluster seed cuts
c     
c------------------------------------------------------------------------
c$$$      parameter (clcutx=7.)     !cluster seed cut (to esclude particles in CN
c$$$                                ! computation and to find clusters in data
c$$$                                ! reduction)
c$$$      parameter (clcuty=7.)
c$$$

c------------------------------------------------------------------------
c     
c     common noise inclusion cut
c     
c------------------------------------------------------------------------
      parameter (cnincut=2.)    !cut to include strips in cluster definition
                                ! during common noise computation


c------------------------------------------------------------------------
c     
c     cluster finding inclusion cut
c     
c------------------------------------------------------------------------
c$$$      parameter (incutx=4.)     !cut to include strips in cluster definition
c$$$                                ! during cluster finding procedure
c$$$      parameter (incuty=4.)
c$$$

*************************************************************************
*     
*     Subroutine inter_B_outer.f
*     
*     it computes the magnetic field in a chosen point x,y,z OUTSIDE the
*     magnetic cavity, using a trilinear interpolation of
*     B field measurements (read before by means of ./read_B.f)
*     the value is computed for the outer map
*     
*     needs:
*     - ../common/common_B_outer.f
*     
*     input: coordinates in m
*     output: magnetic field in T
*     
*************************************************************************

      subroutine inter_B_outer(x,y,z,res) !coordinates in m, magnetic field in T

      implicit double precision (a-h,o-z)
      include '../common/common_B_outer.f'


c------------------------------------------------------------------------
c     
c     local variables
c     
c------------------------------------------------------------------------

      real*8 x,y,z              !point of interpolation
      real*8 res(3)             !interpolated B components: res = (Bx, By, Bz)
      real*8 zin

      integer ic                
c     !index for B components:
c     ! ic=1 ---> Bx
c     ! ic=2 ---> By
c     ! ic=3 ---> Bz
      
      integer cube(3)           
c     !vector of indexes identifying the cube
c     ! containing the point of interpolation
c     ! (see later...)
      
      real*8 xl,xh,yl,yh,zl,zh  !cube vertexes coordinates

      real*8 xr,yr,zr           
c     !reduced variables (coordinates of the 
c     ! point of interpolation inside the cube)

      real*8 Bp(8)              
c     !vector of values of B component 
c     ! being computed, on the eight cube vertexes


c     LOWER MAP
c     ---> up/down simmetry
      zin=z
      if(zin.le.edgelzmax)z=-z

c------------------------------------------------------------------------
c     
c     *** MAP ***
c     
c------------------------------------------------------------------------

      do ic=1,3                 !loops on the three B components

c------------------------------------------------------------------------
c     
c     chooses the coordinates interval containing the input point
c     
c------------------------------------------------------------------------
c     e.g.:
c     
c     x1    x2    x3    x4    x5...               xN
c     |-----|-+---|-----|-----|---- ... ----|-----|
c     ~~~~~~~~x
c     
c     in this case the right interval is identified by indexes 2-3, so the 
c     value assigned to cube variable is 2

        cube(1)=INT((nox-1)*(x-poxmin(ic))/(poxmax(ic)-poxmin(ic))) +1
        cube(2)=INT((noy-1)*(y-poymin(ic))/(poymax(ic)-poymin(ic))) +1
        cube(3)=INT((noz-1)*(z-pozmin(ic))/(pozmax(ic)-pozmin(ic))) +1
        
c------------------------------------------------------------------------
c     
c     if the point falls beyond the extremes of the grid...
c     
c------------------------------------------------------------------------
c     
c     ~~~~~~~~~~x1    x2    x3...
c     - - + - - |-----|-----|----
c     ~~~~x
c     
c     in the case cube = 1
c     
c     
c     ...nx-2  nx-1  nx
c     ----|-----|-----| - - - + - -
c     ~~~~~~~~~~~~~~~~~~~~~~~~x
c     
c     in this case cube = nx-1

        if (cube(1).le.0) cube(1) = 1
        if (cube(2).le.0) cube(2) = 1
        if (cube(3).le.0) cube(3) = 1
        if (cube(1).ge.nox) cube(1) = nox-1
        if (cube(2).ge.noy) cube(2) = noy-1
        if (cube(3).ge.noz) cube(3) = noz-1


c------------------------------------------------------------------------
c     
c     temporary variables definition for field computation
c     
c------------------------------------------------------------------------

        xl = pox(cube(1),ic)    !X coordinates of cube vertexes
        xh = pox(cube(1)+1,ic)

        yl = poy(cube(2),ic)    !Y coordinates of cube vertexes
        yh = poy(cube(2)+1,ic)

        zl = poz(cube(3),ic)    !Z coordinates of cube vertexes
        zh = poz(cube(3)+1,ic)

        xr = (x-xl) / (xh-xl)   !reduced variables
        yr = (y-yl) / (yh-yl)
        zr = (z-zl) / (zh-zl)

        Bp(1) = bo(cube(1)  ,cube(2)  ,cube(3)  ,ic) !ic-th component of B
        Bp(2) = bo(cube(1)+1,cube(2)  ,cube(3)  ,ic) ! on the eight cube
        Bp(3) = bo(cube(1)  ,cube(2)+1,cube(3)  ,ic) ! vertexes
        Bp(4) = bo(cube(1)+1,cube(2)+1,cube(3)  ,ic)
        Bp(5) = bo(cube(1)  ,cube(2)  ,cube(3)+1,ic)
        Bp(6) = bo(cube(1)+1,cube(2)  ,cube(3)+1,ic)
        Bp(7) = bo(cube(1)  ,cube(2)+1,cube(3)+1,ic)
        Bp(8) = bo(cube(1)+1,cube(2)+1,cube(3)+1,ic)

c------------------------------------------------------------------------
c     
c     computes interpolated ic-th component of B in (x,y,z)
c     
c------------------------------------------------------------------------

        res(ic) = 
     +       Bp(1)*(1-xr)*(1-yr)*(1-zr) + 
     +       Bp(2)*xr*(1-yr)*(1-zr) +
     +       Bp(3)*(1-xr)*yr*(1-zr) + 
     +       Bp(4)*xr*yr*(1-zr) +
     +       Bp(5)*(1-xr)*(1-yr)*zr + 
     +       Bp(6)*xr*(1-yr)*zr +
     +       Bp(7)*(1-xr)*yr*zr +
     +       Bp(8)*xr*yr*zr


      enddo     

c     LOWER MAP
c     ---> up/down simmetry 
      if(zin.le.edgelzmax)then
         z=-z                   !back to initial ccoordinate
         res(3)=-res(3)         !invert BZ component
      endif

      return
      end

************************************************************

      subroutine readmipparam
            
      include '../common/commontracker.f'
      include '../common/calib.f'

      character*60 fname_param 
 201  format('trk-LADDER',i1,'-mip.dat')
      do ilad=1,nladders_view         
         write(fname_param,201)ilad
         print *,'Opening file: ',fname_param
         open(10,
     $        FILE='./bin-aux/'//fname_param(1:LNBLNK(fname_param))
     $        ,STATUS='UNKNOWN'
     $        ,IOSTAT=iostat
     $        )
         if(iostat.ne.0)then
            print*,'READMIPPARAM: *** Error in opening file ***'
            return
         endif
         do iv=1,nviews
            read(10,*
     $           ,IOSTAT=iostat
     $           )pip,
     $            mip(int(pip),ilad)
c            print*,ilad,iv,pip,mip(int(pip),ilad)
         enddo
         close(10)
      enddo

      return
      end
*** * * * *** * * * *** * * * *** * * * *** * * * *** * * * ***
      subroutine readchargeparam
      
      
      include '../common/commontracker.f'
      include '../common/calib.f'

      character*60 fname_param 
 201  format('charge-l',i1,'.dat')
      do ilad=1,nladders_view         
         write(fname_param,201)ilad
         print *,'Opening file: ',fname_param
         open(10,
     $        FILE='./bin-aux/'//fname_param(1:LNBLNK(fname_param))
     $        ,STATUS='UNKNOWN'
     $        ,IOSTAT=iostat
     $        )
         if(iostat.ne.0)then
            print*,'READCHARGEPARAM: *** Error in opening file ***'
            return
         endif
         do ip=1,nplanes
            read(10,*
     $           ,IOSTAT=iostat
     $           )pip,
     $            kch(ip,ilad),cch(ip,ilad),sch(ip,ilad)         
c            print*,ilad,ip,pip,kch(ip,ilad),
c     $           cch(ip,ilad),sch(ip,ilad) 
         enddo
         close(10)
      enddo

      return
      end
*** * * * *** * * * *** * * * *** * * * *** * * * *** * * * ***
      subroutine readetaparam
*     -----------------------------------------
*     read eta2,3,4 calibration parameters
*     and fill variables:
*
*     eta2(netabin,nladders_view,nviews)
*     eta3(2*netabin,nladders_view,nviews)
*     eta4(2*netabin,nladders_view,nviews)
*
      include '../common/commontracker.f'
      include '../common/calib.f'

      character*40 fname_binning
      character*40 fname_param
c      character*120 cmd1
c      character*120 cmd2


******retrieve ANGULAR BINNING info
      fname_binning='binning.dat'
      print *,'Opening file: ',fname_binning
      open(10,
     $     FILE='./bin-aux/'//fname_binning(1:LNBLNK(fname_binning))
     $     ,STATUS='UNKNOWN'
     $     ,IOSTAT=iostat
     $     )
      if(iostat.ne.0)then
         print*,'READETAPARAM: *** Error in opening file ***'
         return
      endif
      print*,'---- ANGULAR BINNING ----'
      print*,'Bin   -   angL   -   angR'
 101  format(i2,'       ',f6.2,'     ',f6.2)
      do ibin=1,nangmax
         read(10,*
     $        ,IOSTAT=iostat
     $        )xnn,angL(ibin),angR(ibin)
         if(iostat.ne.0)goto 1000
         write(*,101)int(xnn),angL(ibin),angR(ibin)
      enddo         
 1000 nangbin=int(xnn)
      close(10)
      print*,'-------------------------'
      


      do ieta=2,4               !loop on eta 2,3,4        
******retrieve correction parameters
 200     format(' Opening eta',i1,' files...')
         write(*,200)ieta

 201     format('eta',i1,'-bin',i1,'-l',i1,'.dat')
 202     format('eta',i1,'-bin',i2,'-l',i1,'.dat')
         do iang=1,nangbin
            do ilad=1,nladders_view
               if(iang.lt.10)write(fname_param,201)ieta,iang,ilad
               if(iang.ge.10)write(fname_param,202)ieta,iang,ilad
c               print *,'Opening file: ',fname_param
               open(10,
     $             FILE='./bin-aux/'//fname_param(1:LNBLNK(fname_param))
     $              ,STATUS='UNKNOWN'
     $              ,IOSTAT=iostat
     $              )
               if(iostat.ne.0)then
                  print*,'READETAPARAM: *** Error in opening file ***'
                  return
               endif
               do ival=1,netavalmax
                  if(ieta.eq.2)read(10,*
     $                 ,IOSTAT=iostat
     $                 )
     $                 eta2(ival,iang),
     $                 (feta2(ival,iv,ilad,iang),iv=1,nviews)
                  if(ieta.eq.3)read(10,*
     $                 ,IOSTAT=iostat
     $                 )
     $                 eta3(ival,iang),
     $                 (feta3(ival,iv,ilad,iang),iv=1,nviews)
                  if(ieta.eq.4)read(10,*
     $                 ,IOSTAT=iostat
     $                 )
     $                 eta4(ival,iang),
     $                 (feta4(ival,iv,ilad,iang),iv=1,nviews)
                  if(iostat.ne.0)then
                     netaval=ival-1
c$$$                     if(eta2(1,iang).ne.-eta2(netaval,iang))
c$$$     $                    print*,'**** ERROR on parameters !!! ****' 
                     goto 2000
                  endif
               enddo
 2000          close(10)
*               print*,'... done'
            enddo
         enddo

      enddo                     !end loop on eta 2,3,4


      return
      end

*** * * * *** * * * *** * * * *** * * * *** * * * *** * * * ***
      subroutine readalignparam

      include '../common/commontracker.f'
      include '../common/common_align.f'

      character*50 fname_param
      integer sensor
c      character*120 cmd1
c      character*120 cmd2
      
c 100  format('../common/align_param/parameters_l',i1,'s',i1,'.dat')
 100  format('parameters_l',i1,'s',i1,'.dat')

      do ilad=1,nladders_view
         do is=1,2

            write(fname_param,100)ilad,is
c$$$            cmd1='cp $TRK_GRND/source/common/align_param/'
c$$$     $           //fname_param(1:LNBLNK(fname_param))//' .'         
c$$$            call system(cmd1)         
            print *,'Opening file: ',fname_param

            open(10,
     $           FILE='./bin-aux/'//fname_param(1:LNBLNK(fname_param))
     $           ,STATUS='UNKNOWN'
     $           )
            
            do ip=1,nplanes
*
*     NB! NB! NB! NB! NB!
*     The file labelled for example "l1s1" include the alignment
*     parameters of the column of sensors:
*
*     PLANE LADDER SENSOR
*     -------------------
*     1     1      2
*     2     1      1
*     3     1      1
*     4     1      1
*     5     1      1
*     6     1      1
*
*     This is becouse the plane 1 (bottom plane) is up-side-down
*
               sensor=is
               if(ip.eq.1)sensor=mod(is,2)+1 
               read(10,*)omega(ip,ilad,sensor)
               read(10,*)beta(ip,ilad,sensor)
               read(10,*)gamma(ip,ilad,sensor)
               
c     N.B. I convert angles from microradiants to radiant
               omega(ip,ilad,sensor)=omega(ip,ilad,sensor)/1.d6
               beta(ip,ilad,sensor)=beta(ip,ilad,sensor)/1.d6
               gamma(ip,ilad,sensor)=gamma(ip,ilad,sensor)/1.d6

               read(10,*)dx(ip,ilad,sensor)
               read(10,*)dy(ip,ilad,sensor)
               read(10,*)dz(ip,ilad,sensor)
            enddo
            
            close(10)
c$$$            cmd2='rm -f '
c$$$     $           //fname_param(1:LNBLNK(fname_param))
c$$$            call system(cmd2)
         enddo
      enddo
      
  

      end
c------------------------------------------------------------------------

c     NB: le coordinate in mech_pos.dat sono calcolate a partire da alcuni dati
c     contenuti in commontracker.f. forse si puo' evitare mech_pos.dat e mettere
c     tutto in commontracker.f


      subroutine mech_sensor    
c     !it reads sensors coordinates (in PAMELA reference
c     ! frame) from a text file and it uses them to fill
c     ! x/y/z_mech_sensor variables, taking into account
c     ! last plane inversion

      include './commontracker.f'
      include './common_tracks.f'

      real xvec(nladders_view),yvec(2),zvec(nplanes)

      integer id                !file identifier
      logical od                !.true. if the specified unit is connected to a file

      do id=20,100,1            !opens the file using a free file id
        inquire (id, opened=od)
        if(.not.od) goto 666
      enddo      
 666  continue

c      open(id,FILE='../common/mech_pos.dat') !sensors centres coordinates in mm in 
c      open(id,FILE='source/common/mech_pos.dat') 
c      call system('cp $TRK_GRND/source/common/mech_pos.dat .')
      print *,'Opening file: mech_pos.dat'
      open(id,FILE='./bin-aux/mech_pos.dat',IOSTAT=iostat) 
c     !sensors centres coordinates in mm in 
c     ! PAMELA reference frame:
c     ! the first plane is the one with lowest Z (the one
c     ! nearest the calorimeter)
c     ! the first ladder is the one with lowest X (the
c     ! one on which the first X strip is)
c     ! the first sensor is the one with lowest Y (the
c     ! one on which the first Y strip is) for planes
c     ! 2..6. for plane 1 the first sensor has higher Y
      
      if(iostat.ne.0)then
         print*,'MECH_SENSOR: *** Error in opening file ***'
         return
      endif

      read(id,*) xvec
      read(id,*) yvec
      read(id,*) zvec

      do i=1,nplanes
        do j=1,nladders_view
          do k=1,2
            x_mech_sensor(i,j,k)=xvec(j)
            y_mech_sensor(i,j,k)=yvec(k)
            z_mech_sensor(i,j,k)=zvec(i)
            if(i.eq.1) then     !y coordinates of first plane (11th view) are
              y_mech_sensor(i,j,k)=-yvec(k) ! exchanged due to last plane inversion
            endif              
          enddo
        enddo
      enddo

      close(id)
c      call system('rm -f mech_pos.dat')

c$$$                                ! *** INIZIO DEBUG ***
c$$$      do i=1,6
c$$$c        do j=1,3
c$$$          do k=1,2
c$$$            j=1
c$$$c            print*,x_mech_sensor(1,j,k)
c$$$            print*,y_mech_sensor(i,j,k)
c$$$c            print*,z_mech_sensor(i,j,k)
c$$$          enddo
c$$$c        enddo
c$$$        print*,' '
c$$$      enddo
c$$$                                ! *** FINE DEBUG ***

      
      return
      end

*************************************************************************
*     
*     Common level2.f
*     
*     contains LEVEL2 ntuple variables definitions
*     
*    
*     11/09/2005 modified by david fedele to include general variables
*     07/10/2005 modified by elena vannuccini --> (2)
*
*************************************************************************

      PARAMETER (NTRKMAX=50)    !ncloyz_max*ncloxz_max)
c*****************************************************
cccccc 11/9/2005 modified by david fedele
      PARAMETER (NSINGMAX=500)
ccc   EVENT block*********
c     GENERAL block:
c***************************************************
*     -----------------------------------------------------------
      logical good2             !flag to mark good or noise events
      integer nev2              !level2 event number
c*****************************************************
cccccc 11/9/2005 modified by david fedele
      integer which_calib       !calibration file identifier. see DW_DATE_NUM_calib.txt file
      integer swcode            !version of the software
      logical crc(12)           !DSP crc controll
c      common/level2/good2,nev2
cccccc 06/10/2005 modified by elena vannuccini
c      common/level2/good2,nev2,which_calib,swcode
      common/level2/good2,nev2,which_calib,swcode,crc
c*****************************************************



c     CPU block (only for ground data):
*     -----------------------------------------------------------
      integer pkt_type          !CPU packet type identifier. see http://people.roma2.infn.it/~cpu/HB_list.txt
c     0x12 --> calibration board 0                  
c     0x13 --> calibration board 1              
c     0x10 --> event                            
c     0x30 --> full event for calib special     
c     0x83 --> tracker ALARM (control register) 
      integer pkt_num           !CPU packet number
      integer obt               !CPU on-board time
c*****************************************************
cccccc 11/9/2005 modified by david fedele
c      integer which_calib       !calibration file identifier. see DW_DATE_NUM_calib.txt file
c      common/level2_cpu/pkt_type,pkt_num,obt,which_calib
      logical cpu_crc           !CPU crc controll
      common/level2_cpu/pkt_type,pkt_num,obt,cpu_crc
c****************************************************

*     -----------------------------------------------------------
*     Common to store TRACK info
*     All the variables have a dimention equal to the number of
*     found tracks
*     -----------------------------------------------------------
c     TRACK PARAMETERS      
      integer ntrk              !# identified tracks
      integer image             !flag to tag track-images
      real al_nt                !track state vector
      real coval                !covariance matrix
      integer xgood_nt          !mask of used planes
      integer ygood_nt          !*
      real xm_nt                !measured points
      real ym_nt                !*
      real zm_nt                !*
      real resx_nt              !spatial resolution
      real resy_nt              !*
      real chi2_nt              !chi2
      real xv_nt                !calculated points
      real yv_nt                !*
      real zv_nt                !*
      real axv_nt               !calculated angles (deg)
      real ayv_nt               !*
c*****************************************************
cccccc 11/9/2005 modified by david fedele
c      real dedxp                !signal in MIP scaled to 300 micrometer
      real dedx_x              !signal in MIP scaled to 300 micrometer
      real dedx_y              !signal in MIP scaled to 300 micrometer
cccccc 06/10/2005 add by elena vannuccini
      real bdl
c****************************************************

      common/level2_tracks/
     $      ntrk
     $     ,image(NTRKMAX)
     $     ,xm_nt(nplanes,NTRKMAX)
     $     ,ym_nt(nplanes,NTRKMAX)
     $     ,zm_nt(nplanes,NTRKMAX)
     $     ,resx_nt(nplanes,NTRKMAX)
     $     ,resy_nt(nplanes,NTRKMAX)
     $     ,al_nt(5,NTRKMAX)
     $     ,coval(5,5,NTRKMAX)
     $     ,chi2_nt(NTRKMAX)
     $     ,xgood_nt(nplanes,NTRKMAX)
     $     ,ygood_nt(nplanes,NTRKMAX)
     $     ,xv_nt(nplanes,NTRKMAX)
     $     ,yv_nt(nplanes,NTRKMAX)
     $     ,zv_nt(nplanes,NTRKMAX)
     $     ,axv_nt(nplanes,NTRKMAX)
     $     ,ayv_nt(nplanes,NTRKMAX)
c*****************************************************
cccccc 27/9/2005 modified by david fedele
c     $     ,dedxp(nplanes,NTRKMAX)
     $     ,dedx_x(nplanes,NTRKMAX)
     $     ,dedx_y(nplanes,NTRKMAX)
c*****************************************************
cccccc 06/10/2005 modified by elena vannuccini
c     $     ,crc(12)
     $     ,bdl(NTRKMAX)

*     -----------------------------------------------------------
*     Common to store SINGLET info
*     (clusters not associated with any track) 
*     -----------------------------------------------------------
      
      integer nclsx             !# unassociated clusters  X views
c*****************************************************
cccccc 11/9/2005 modified by david fedele
      integer planex            !plane of single x
      real xs                   !center coord of single x
      real sgnlxs               !signal in MIP of single x
      common/level2_singletsx/
c    $     nclsx,planex(NSINGMAX),xs(NSINGMAX),sgnlxs(NSINGMAX)   !(2)
     $     nclsx,planex(NSINGMAX),xs(2,NSINGMAX),sgnlxs(NSINGMAX) !(2)

      integer nclsy             !     "            "      Y views
      integer planey            !plane of single y
      real ys                   !center coord of single y
      real sgnlys               !signal in MIP of single y

      common/level2_singletsy/
c    $     nclsy,planey(NSINGMAX),ys(NSINGMAX),sgnlys(NSINGMAX)   !(2)
     $     nclsy,planey(NSINGMAX),ys(2,NSINGMAX),sgnlys(NSINGMAX) !(2)
*********************************************************

      subroutine readalignparam

      include '../common/commontracker.f'
      include '../common/common_align.f'

      character*50 fname_param
      integer sensor
c      character*120 cmd1
c      character*120 cmd2
      
c 100  format('../common/align_param/parameters_l',i1,'s',i1,'.dat')
 100  format('parameters_l',i1,'s',i1,'.dat')

      do ilad=1,nladders_view
         do is=1,2

            write(fname_param,100)ilad,is
c$$$            cmd1='cp $TRK_GRND/source/common/align_param/'
c$$$     $           //fname_param(1:LNBLNK(fname_param))//' .'         
c$$$            call system(cmd1)         
            print *,'Opening file: ',fname_param

            open(10,
     $           FILE='./bin-aux/'//fname_param(1:LNBLNK(fname_param))
     $           ,STATUS='UNKNOWN'
     $           )
            
            do ip=1,nplanes
*
*     NB! NB! NB! NB! NB!
*     The file labelled for example "l1s1" include the alignment
*     parameters of the column of sensors:
*
*     PLANE LADDER SENSOR
*     -------------------
*     1     1      2
*     2     1      1
*     3     1      1
*     4     1      1
*     5     1      1
*     6     1      1
*
*     This is becouse the plane 1 (bottom plane) is up-side-down
*
               sensor=is
               if(ip.eq.1)sensor=mod(is,2)+1 
               read(10,*)omega(ip,ilad,sensor)
               read(10,*)beta(ip,ilad,sensor)
               read(10,*)gamma(ip,ilad,sensor)
               
c     N.B. I convert angles from microradiants to radiant
               omega(ip,ilad,sensor)=omega(ip,ilad,sensor)/1.d6
               beta(ip,ilad,sensor)=beta(ip,ilad,sensor)/1.d6
               gamma(ip,ilad,sensor)=gamma(ip,ilad,sensor)/1.d6

               read(10,*)dx(ip,ilad,sensor)
               read(10,*)dy(ip,ilad,sensor)
               read(10,*)dz(ip,ilad,sensor)
            enddo
            
            close(10)
c$$$            cmd2='rm -f '
c$$$     $           //fname_param(1:LNBLNK(fname_param))
c$$$            call system(cmd2)
         enddo
      enddo
      
  

      end

      SUBROUTINE access_level1
*
      include '../common/commontracker.f'
      include '../common/level1.f'

      ntpid=ntp_level1+20

      CALL HBNAME(ntpid,' ',0,'$CLEAR')
c*****************************************************
cccccc 10/9/2005 modified by david fedele
c      CALL HBNAME(ntpid,'EVENT',GOOD1,'$SET')
      CALL HBNAME(ntpid,'GENERAL',GOOD1,'$SET')
******************************************************
*
      CALL HBNAME(ntpid,'CPU',PKT_TYPE1,'$SET')
*
      CALL HBNAME(ntpid,'CLUSTER',NCLSTR1,'$SET')
*
      CALL HBNAME(ntpid,'CNOISE',CNEV,'$SET')
*

*
      return
      END

*************************************************************************
*     
*     Common level0_2003.f
*     
*     contains LEVEL0 ntuple variables definitions for 2003 test
*     
*     to be included in:
*     - ../readraw/readraw.F
*     - ../reduction/reduction.f
*     - !???
*     
*     10/9/2005 modified by david fedele to include general variables
*************************************************************************


c*****************************************************
cccccc 10/9/2005 modified by david fedele
ccc   EVENT block*********
c     GENERAL block:
c***************************************************
      logical good0             !flag to mark good or noise events
      integer nev0              !level0 event number
c*****************************************************
cccccc 10/9/2005 modified by david fedele
      integer which_calib       !calibration file identifier. see DW_DATE_NUM_calib.txt file
      integer swcode            !version of the software
c*****************************************************
      
c     CPU block:
      integer pkt_type          !CPU packet type identifier. see http://people.roma2.infn.it/~cpu/HB_list.txt
c     0x12 --> calibration board 0                  
c     0x13 --> calibration board 1              
c     0x10 --> event                            
c     0x30 --> full event for calib special     
c     0x83 --> tracker ALARM (control register) 
      integer pkt_num           !CPU packet number
      integer obt               !CPU on-board time
c*****************************************************
cccccc 10/9/2005 modified by david fedele
c      integer which_calib       !calibration file identifier. see DW_DATE_NUM_calib.txt file
      logical cpu_crc           !CPU crc controll
c*****************************************************


c     HEADER block:
c     header variables for each view:
      integer DAQmode(12)       !9  = full acquisition mode
                                !10 = compressed acquisition mode
                                !11 = compressed+full acquisition mode
      integer DSPnumber(12)     !view number
      integer DATAlength(12)    !data buffer length
      integer eventn(12)        !DSP event number
      integer nclust(12)        !nclust*2+1 = number of strips to be 
                                ! included in cluster
      integer cutc(12)          !cut to include strips in a cluster
      integer cutcl(12)         !cut to search for clusters
      integer addrcluster(12,3) !address of the greatest cluster(view,ladder)
      integer signcluster(12,3) !signal of the greatest cluster(view,ladder)
      integer fc(12)            !compression flag
      integer compressiontime(12) !DSP program compression time
      integer fl5(12)           !flag
      integer fl4(12)           !flag
      integer fl3(12)           !flag
      integer fl2(12)           !flag
      integer fl1(12)           !flag
      integer fl6(12)           !flag
      integer checksum(12)      !DSP header checksum
      integer pnum(12)          !peripheral number
      integer cmdnum(12)        !command number
      integer bid(12)           !board identifier
      integer alarm(12)         !alarm
      integer aswr(12)          !response length
c*****************************************************
cccccc 10/9/2005 modified by david fedele
      logical crc(12)           !DSP crc controll
c*****************************************************

      

c     DATA block:
      integer TOTDATAlength     !sum of all views datalength (to assign 
                                ! dimension to datatracker array)
      integer datatracker(49152) !data tracker buffer (.DAT raw data)


c*****************************************************
cccccc 10/9/2005 modified by david fedele
c      common/level0_event/good0,nev0
c     $     ,pkt_type,pkt_num,obt,which_calib
c     $     ,DAQmode,DSPnumber,DATAlength,eventn,nclust,cutc,cutcl
c     $     ,addrcluster,signcluster,fc,compressiontime
c     $     ,fl5,fl4,fl3,fl2,fl1,fl6,checksum
c     $     ,TOTDATAlength,datatracker,pnum,cmdnum,bid,alarm,aswr
      common/level0_event/good0,nev0,which_calib,swcode
     $     ,pkt_type,pkt_num,obt,cpu_crc
     $     ,DAQmode,DSPnumber,DATAlength,eventn,nclust,cutc,cutcl
     $     ,addrcluster,signcluster,fc,compressiontime
     $     ,fl5,fl4,fl3,fl2,fl1,fl6,checksum,crc,TOTDATAlength
     $     ,datatracker,pnum,cmdnum,bid,alarm,aswr
c***********************************************************
      

      subroutine fill_acq_head
      include '../common/common_hbook.F'
      include '../common/common_io.F'
      include '../common/common_acq.F'
      include '../common/common_packet.F'
      
      R_header=R_header+1
      
      Rhead_counter = CPU_counter
      Rhead_obt = CPU_obt
      Rhead_wlen = CPU_pkt_len
c$$$      do i=1,Rhead_wlen
c$$$         Rhead_buffer(i) = iand(z'000000ff',buffer(i))
c$$$      enddo
      ip=1
      call getbytes(4,buffer,ip,RHD_stamp)
      call getbytes(1,buffer,ip,RHD_acq_mode)
      call getbytes(4,buffer,ip,RHD_obt_ts)
      call getbytes(4,buffer,ip,RHD_last_ts)
      call getbytes(1,buffer,ip,RHD_fav_ws)
      call getbytes(1,buffer,ip,RHD_eff_ws)
      call getbytes(4,buffer,ip,RHD_trigA)
      call getbytes(4,buffer,ip,RHD_trigB)
      call getbytes(1,buffer,ip,RHD_acq_after_calib)
      call getbytes(4,buffer,ip,RHD_trk_calib_used)
      call getbytes(4,buffer,ip,RHD_acq_build)
      call getbytes(1,buffer,ip,RHD_acq_var)
      call getbytes(1,buffer,ip,RHD_cal_dsp_mask)

      call HFNT(ntp_acq_head)

      return
      end

************************************************************************
*     
*     Program scancalibs.f
*     
*     
*************************************************************************

      program scancalibs

      include '../common/commontracker.f'
      include '../common/common_readraw.f'
c      include '../common/level0.f'
      include '../common/calib.f'
      include '../commonyoda/trk_calib_parameters.f'

      integer trk_DSP_ok(nviews)!mask of found DSP packets
      common/DSPok/trk_DSP_ok

c------------------------------------------------------------------------
c     
c     local variables
c     
c------------------------------------------------------------------------
      parameter (nfile_max=20)

      character*24 processing_date

c     local variables for input files
      character*60 name_temp
      character*3 aa(nfile_max)
      character*2 aaa
      character*40 in_file(nfile_max) !input data file
      character*40 in_dir             !input data dir
      character*40 out_dir      !output dir
      character*60 out_file     !output rz file
      character*60 out_file_runinfo !output log file
      character*60 out_file_level0  !output rz file (level 0)
      character*60 out_file_calib   !output rz file (calibration)
      character*8 date 
      character*3 particle

      integer file_id(nfile_max),file_events(nfile_max)

      character*200 copystring

      integer this_eventn
c      integer this_calib

c     local variables for data unpacking 
      logical found_cal_pkt     !flag for calibration packets
      integer ffd               !input file descriptor
      integer runerror          !readevent error flag
c      integer ffd_pkt           !pkt file descriptor
c                                !(file temporaneo)     
      integer*4 CPU_pkt_counter
      integer pkt_type

c      integer ndummy
c      data ndummy/1000/

      logical trk_link(2)

      
c     local parameters
      parameter (lun_out_file_runinfo=49)!txt log file id number
      parameter (lun_out_file_calib=50) !output file id number
      parameter (lun_out_file_level0=51) !output file id number

      parameter (lun_in_file=52) !input file id number

      parameter (lun_pkt=53) !inpunt temp packet file


      parameter (max_event_number=50000) !maximum number of events
           

c------------------------------------------------------------------------
c     
c     reads input informations (through < go_readraw)
c     
c------------------------------------------------------------------------

      print*,'______________________________________________'

      print*,'Number of files to be analysed:'
      read(*,*)nfile
      print*,nfile
      print*,'Date YYMMDD:'
 300  format(a6)
      read(*,300)date
      print*,date
      print*,'List of file identifiers:'
 401  format('output_',A6,'_',A3,'.dat') !file name
c 402  format('dt_temp/')        !directory
      read(*,*)(file_id(i),i=1,nfile)
      write(*,*)(file_id(i),i=1,nfile)
c      write(in_dir,402)date
c      in_dir='dt_temp/'
      in_dir='raw-data/'
      do i=1,nfile
         iii = file_id(i)
         call intstr(iii,aa(i),3)
c         write(name_temp,400)date,date,aa(i)
         write(name_temp,401)date,aa(i)
         in_file(i)=name_temp(1:LNBLNK(name_temp))
         print*,in_file(i)
         file_events(i)=0
      enddo 
      
 499  format(A40)
      print*,'output directory:'
      read(*,499)out_dir
      print*,out_dir
c      out_dir='rz/'
      print*,'Total number of events to be analized:'
      read(*,*)nev_total
      print*,nev_total
      print*,'______________________________________________'

c------------------------------------------------------------------------
c     
c     Opening log-file RUNINFO
c     
c     
c------------------------------------------------------------------------
      out_file_runinfo='scancalibs.dat'
      print*,'OUTPUT FILE: ',
     $     out_dir(1:LNBLNK(out_dir))
     $     //out_file_runinfo(1:LNBLNK(out_file_runinfo))
      open(UNIT=lun_out_file_runinfo
     $     ,FILE=out_dir(1:LNBLNK(out_dir))
     $     //out_file_runinfo(1:LNBLNK(out_file_runinfo))
     $     ,ACCESS='APPEND'
     $     ,FORM='FORMATTED'
     $     ,STATUS='UNKNOWN'
     $     )
*-------------------------------------------------------------
*
*     start loop on data files
*
*
*------------------------------------------------------------
*     some flags to check the data stream
      found_cal_pkt=.false.
      n_cal_pkt=0
      n_cal_pkt_last=0

      nev0_c = 0                !global event counter
      nev0_good = 0
      trk_link(1)=.false.
      trk_link(2)=.false.
                  
      do ifile = 1,nfile        !loop on data files
         
         print*,' '
         print*,'OPENING PARTICLE FILE:'
         print*,in_file(ifile)
         print*,' '

         open(unit=lun_in_file, 
     $        file=in_dir(1:LNBLNK(in_dir))
     $        //in_file(ifile)(1:LNBLNK(in_file(ifile))), 
     $        status='old', 
     $        form='unformatted', 
     $        err=22)
         ffd = FNum(lun_in_file) !reads unix file descriptor
         
         file_events(ifile)=0   !sigle-file event counter 
         nev_file_good = 0
c         good0 = .true.
         this_eventn=0

         this_CPU_pkt = 0
         do iev = 1,min(nev_total,max_event_number) !events loop
****************************************************************
*     this routine search for a cpu header pointing to a tracker
*     packet, and save the content in a temp file
*     >>>>>>  packet.dat  <<<<<<
            call findcpuheader(runerror,ffd,pkt_type,CPU_pkt_counter)
            if(runerror.eq.-1) goto 24
            if(runerror.eq.1) then                  
               print*,' '
               print*,'readraw: FILE: ',in_file(ifile)
               print*,'readraw: END OF FILE AT EVENT ',iev-1
               print*,'_____________________________________ '
c              goto 9900        !end loop on files 
            endif
c            print *,'>>> Previous CPU pkt',this_CPU_pkt
c            print *,'>>> Current  CPU pkt',CPU_pkt_counter
            if(CPU_pkt_counter.le.this_CPU_pkt)then
               print*,'  '
c               print*,' >> The CPU pkt number is not progressive << '
c               print*, ' (I suppose that what follows is rubbish) '
               goto 9900 !next file
            endif
            this_CPU_pkt = CPU_pkt_counter
            name_temp='packet.dat'
            if(pkt_type.eq.z'12'.or.pkt_type.eq.z'13')then
               if(pkt_type.eq.z'12')then
                  trk_link(1)=.true.
                  print*,'Found link 1 >> ',trk_link(1),trk_link(2)
               else
                  trk_link(2)=.true.
                  print*,'Found link 2 >> ',trk_link(1),trk_link(2)
               endif
c--**--**--**--**--**--**--**--**--**--**--**--**--**--**--**
c     -----------
c     CALIBRATION
c     -----------
c--**--**--**--**--**--**--**--**--**--**--**--**--**--**--**

               
c               call trk_calib_pkt(runerror,ffd_pkt)
               call trkcalibpkt(runerror,name_temp)

 222           format(i3,3i6,6i4)
               do iview=1,6
                  write(lun_out_file_runinfo,222)
     $                 DSPnumber(iview),
     $                 ped_l1(iview),ped_l2(iview),ped_l3(iview),
     $                 sig_l1(iview),sig_l2(iview),sig_l3(iview),
     $                 nbad_l1(iview),nbad_l2(iview),nbad_l3(iview)
                  write(*,222)
     $                 DSPnumber(iview),
     $                 ped_l1(iview),ped_l2(iview),ped_l3(iview),
     $                 sig_l1(iview),sig_l2(iview),sig_l3(iview),
     $                 nbad_l1(iview),nbad_l2(iview),nbad_l3(iview)
               enddo

               
 2222          continue
               
            elseif(pkt_type.eq.z'10'.or.pkt_type.eq.z'30')then
c--**--**--**--**--**--**--**--**--**--**--**--**--**--**--**
c     -----
c     EVENT
c     -----
c--**--**--**--**--**--**--**--**--**--**--**--**--**--**--**
c               call trkeventpkt(runerror,name_temp)
 8800          continue
            endif               !end pkt type conditions



            if(
     $           (pkt_type.eq.z'10'.or.pkt_type.eq.z'30').and.
     $           .true.) then
c----------------------------------------------------------------
c     an EVENT was found,
c----------------------------------------------------------------
               
            elseif(
     $              (pkt_type.eq.z'12'.or.pkt_type.eq.z'13').and.
     $              trk_link(1).eqv..true..and.
     $              trk_link(2).eqv..true..and.
     $              .true.) then
               print*,trk_link(1),trk_link(2),pkt_type
c----------------------------------------------------------------
c     a calibration packet was found
c----------------------------------------------------------------
               n_cal_pkt = n_cal_pkt + 1
               nnnn=n_cal_pkt 
               call intstr(nnnn,aaa,2)
*     ***********************************************************
*     ***********************************************************
*     ***********************************************************
*     ***********************************************************
*     write the output
*     ***********************************************************
               write(lun_out_file_runinfo,*)
     $              '----- ',date,file_id(ifile),n_cal_pkt
               write(*,*)
     $              '----- ',date,file_id(ifile),n_cal_pkt

              
               

*     ***********************************************************
*     ***********************************************************
*     ***********************************************************
*     ***********************************************************
*     ***********************************************************
               
               do iview=1,nviews
                  trk_DSP_ok(iview)=0 !init DSP flag
               enddo
               trk_link(1)=.false.
               trk_link(2)=.false.
               




            endif
 9909       continue
         enddo                  !end loop on events
 9900    continue
         close(lun_in_file)


      enddo                     !end loop on data files
      
      close(lun_out_file_runinfo)

 9990 continue
      goto 9000                 !go to end
c-----------------------------------------     
c     output file creation error
c-----------------------------------------
 19   continue      
      print*,' '
      print*,'readraw: ERROR CREATING OUTPUT FILE: ',out_file
      print*,istat
      print*,' '
      print*,' '
      goto 9000                !the end
c-----------------------------------------     
c     particle input file opening error     
c-----------------------------------------
 22   continue
      print*,' '
      print*,'readraw: ERROR OPENING PARTICLE FILE: ',in_file(ifile)
      print *,in_dir
      print *,in_dir(1:LNBLNK(in_dir))
     $        //in_file(ifile)(1:LNBLNK(in_file(ifile)))
      print*,' '
      goto 9000                !the end
c-----------------------------------------     
c     event found before calibration packet  
c-----------------------------------------
 20   continue
      print*,' '
      print*,'readraw: EVENT FOUND BEFORE CALIBRATION PACKET: '
      print*,in_file(ifile)
      print*,' '
      goto 9000                !the end
c-----------------------------------------
c     particle input file reading error     
c-----------------------------------------
 23   continue
      print*,' '
      print*,'readraw: END OF FILE: ',in_file(ifile)
      print*,'readraw: FOWND AT EVENT ',iev
      print*,' '
      goto 9000                 !the end
 24   continue
      print*,' '
      print*,'readraw: ERROR READING PARTICLE FILE: ',in_file(ifile)
      print*,'readraw: READ ERROR AT EVENT ',iev
      print*,' '
      goto 9000                 !the end

c------------------------------------------------------------------------
c     
c     closes files and exits
c     
c------------------------------------------------------------------------
 9000 continue
      


      stop
      end



c      include 'readraw_subroutines.f'
c      include 'trkunpack.f'

*************************************************************************
*     
*     Common level1.f
*     
*     contains LEVEL1 ntuple variables definitions
*     
*     to be included in:
*     - ../reduction/reduction.f
*     - ../analysis/analysis.f
*     - !???
*     
*     parameters:
*     - nclstrmax
*     - nclstrp
*    
*     11/9/2005 modified by david fedele to include general variables
*************************************************************************


c*****************************************************
cccccc 11/9/2005 modified by david fedele
ccc   EVENT block*********
c     GENERAL block:
c***************************************************
      logical good1             !flag to mark good or noise events
      integer nev1              !level1 event number
c*****************************************************
cccccc 11/9/2005 modified by david fedele
      integer which_calib1       !calibration file identifier. see DW_DATE_NUM_calib.txt file
      integer swcode1            !version of the software
c*****************************************************

c     CPU block (only for ground data):
      integer pkt_type1         !CPU packet type identifier. see http://people.roma2.infn.it/~cpu/HB_list.txt
c     0x12 --> calibration board 0                  
c     0x13 --> calibration board 1              
c     0x10 --> event                            
c     0x30 --> full event for calib special     
c     0x83 --> tracker ALARM (control register) 
      integer pkt_num1          !CPU packet number
      integer obt1              !CPU on-board time
c*****************************************************
cccccc 11/9/2005 modified by david fedele
c      integer which_calib1       !calibration file identifier. see DW_DATE_NUM_calib.txt file
      logical cpu_crc1           !CPU crc controll
c*****************************************************

c     CLUSTER block:
      integer nclstr1           !cluster number
      integer view(nclstrmax)   !view the cluster belongs to
      integer ladder(nclstrmax) !ladder the strip carrying the largest signal 
                                ! value belongs to
      integer maxs(nclstrmax)   !cluster strip carrying the largest signal value
      integer mult(nclstrmax)   !cluster multiplicity
      real dedx(nclstrmax)      !cluster multiplicity
      integer indstart(nclstrmax) !cluster starting point index in clsignal array
      integer indmax(nclstrmax) !cluster maximum point index in clsignal array
      integer totCLlength       !sum of all clusters length (to assign
                                ! dimension to clsignal array)
      real clsignal(maxlength)  !signal values of all strips belonging to clusters
c*****************************************************
cccccc 11/9/2005 modified by david fedele
c      integer which_calib1       !calibration file identifier. see DW_DATE_NUM_calib.txt file
      logical crc1(12)           !DSP crc controll
c*****************************************************

c     CNOISE block:
      real cnev(nviews,nva1_view) !common noise of the event for a certain view and
                                ! VA1
c*****************************************************
cccccc 11/9/2005 modified by david fedele
c      common/level1_general/good1,nev1
c      common/level1_cpu/pkt_type1,pkt_num1,obt1,which_calib1
c      common/level1_cluster/nclstr1,view,ladder,maxs,mult,dedx,indstart
c     $     ,indmax,totCLlength,clsignal,cnev
      common/level1_general/good1,nev1,which_calib1,swcode1,crc1
      common/level1_cpu/pkt_type1,pkt_num1,obt1,cpu_crc1
      common/level1_cluster/nclstr1,view,ladder,maxs,mult,dedx,indstart
     $     ,indmax,totCLlength,clsignal,cnev
c**********************************************************

*************************************************************************
*     
*     Common common_B_2maps.f
*     
*     to be included in:
*     - ../magnet/read_B_2maps.f
*     - ../magnet/inter_B_2maps.f
*
*     parameters:
*     - nx, ny, nz : number of measures along X, Y and Z axes
*  
*************************************************************************

      implicit double precision (a-h,o-z)


      parameter (nx=29, ny=23, nz=101) !number of measures along X, Y and Z 
                                ! axes

************
c     first map      
      real*8 px1(nx,3),py1(ny,3),pz1(nz,3) !coordinates of measure points:
                                ! e.g. py(ny,1) = Y coordinates of Bx (=1)
                                ! component of magnetic field

      real*8 b1(nx,ny,nz,3),db1(nx,ny,nz,3) !magnetic field values and error:
                                ! e.g. b(nx,ny,nz,2) = By (=2) component of
                                ! magnetic field measured in (nx, ny, nz)

      common/interpolation1/px1,py1,pz1,b1,db1

************
c     second map
      real*8 px2(nx,3),py2(ny,3),pz2(nz,3)
      real*8 b2(nx,ny,nz,3),db2(nx,ny,nz,3)

      common/interpolation2/px2,py2,pz2,b2,db2

      SUBROUTINE access_level0
*
c*****************************************************
cccccc24/09/2005 modified by david fedele  --> (1)
cccccc14/10/2005 modified by elena         --> (2)
c*****************************************************
      include '../common/level0.f'

*
      CALL HBNAME(20,' ',0,'$CLEAR')
c     CALL HBNAME(20,'EVENT',GOOD0,'$SET')   !(1)
      CALL HBNAME(20,'GENERAL',GOOD0,'$SET') !(1)
*
      CALL HBNAME(20,'CPU',PKT_TYPE,'$SET') !(2)
*
      CALL HBNAME(20,'HEADER',DAQMODE,'$SET')
*
c     CALL HBNAME(20,'CPU',PKT_TYPE,'$SET') !(2)
*
      CALL HBNAME(20,'DATA',TOTDATALENGTH,'$SET')
*
      CALL HBNAME(20,'TRAILER',TRAILER1,'$SET')
*
*
      END
